//
// automatically generated by spin2cpp v1.94 on Sun Sep 25 16:00:57 2016
// C:\Users\Dave\Desktop\s3_spin\temp\spin2cpp.exe --ccode scribbler_test.spin 
//

// Copyright (c) 2008 Philip C. Pilgrim
// (See end of file for terms of use.)
//
// -----------[ Description ]----------------------------------------------------
//
// This Propeller object provides up to eight leading-edge-aligned PWM channels
// with resolution determined by a defined constant. The maximum PWM frequency
// is the lesser of:
//
//    clkfreq / (13.5 * resolution) and 20.648881 / resolution MHz
//
// The minimum PWM frequency is :
// 
//    clkfreq / (40000 * resolution)
//
// PWM output is generated using the Propeller's video generator in VGA mode. The
// eight or fewer channels can be any subset of the pins in one of four
// contiguous blocks: A0-A7, A8-A15, A16-A23, or A24-A31.
//
// -----------[ History ]--------------------------------------------------------
//
// Version 1.1: 17 Jul 08: Fixed a couple bugs related to base pins > 0.
// Version 1.2: 20 Jan 10: Fixed a bug relating to duty modes of 256 (i.e. full on).
//
// -----------[ Program ]--------------------------------------------------------
#include <propeller.h>
#include "PWMx8.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

INLINE__ int32_t Shr__(uint32_t a, uint32_t b) { return (a>>b); }
static uint8_t dat[] = {
  0x00, 0x7c, 0xfc, 0x08, 0xf0, 0x6f, 0xbc, 0xa0, 0x37, 0x84, 0xbc, 0x08, 0x04, 0x6e, 0xfc, 0x80, 
  0x37, 0x7e, 0xbc, 0x08, 0x04, 0x6e, 0xfc, 0x80, 0x3f, 0x80, 0xbc, 0xa0, 0x04, 0x7e, 0xfc, 0x28, 
  0x1c, 0x80, 0xfc, 0x2c, 0x00, 0x82, 0xfc, 0xa0, 0x36, 0x7e, 0x3c, 0x85, 0x10, 0x00, 0x4c, 0x5c, 
  0x01, 0x80, 0xfc, 0x2d, 0x01, 0x7e, 0xfc, 0x34, 0x01, 0x82, 0xfc, 0x80, 0x0a, 0x00, 0x7c, 0x5c, 
  0x3f, 0x74, 0xbc, 0xa0, 0x40, 0x76, 0xbc, 0xa0, 0x3e, 0x78, 0xbc, 0xa0, 0x2b, 0x64, 0xfc, 0x5c, 
  0x3b, 0xf4, 0xbf, 0xa0, 0x07, 0x82, 0xfc, 0x87, 0x19, 0x00, 0x44, 0x5c, 0x41, 0x82, 0xbc, 0xa4, 
  0x1b, 0x00, 0x7c, 0x5c, 0x41, 0x66, 0xbc, 0x2c, 0x00, 0x82, 0xfc, 0xa0, 0x33, 0xfe, 0xbf, 0xa0, 
  0x17, 0x82, 0xfc, 0x2c, 0x34, 0x82, 0xbc, 0x68, 0x41, 0xf0, 0xbf, 0xa0, 0x37, 0xfc, 0xbf, 0x08, 
  0x04, 0x6e, 0xfc, 0x80, 0x37, 0xec, 0xbf, 0x08, 0x04, 0x6e, 0xfc, 0x80, 0x37, 0x6e, 0xbc, 0x08, 
  0x37, 0x70, 0xbc, 0xa0, 0x42, 0x72, 0xbc, 0xa0, 0x38, 0x6a, 0xbc, 0x08, 0x04, 0x70, 0xfc, 0x80, 
  0xe4, 0x6a, 0x7c, 0xfc, 0x26, 0x72, 0xfc, 0xe4, 0x24, 0x00, 0x7c, 0x5c, 0x20, 0x7a, 0xfc, 0xa1, 
  0x01, 0x76, 0xfc, 0x35, 0x01, 0x74, 0xfc, 0x35, 0x3c, 0x74, 0xb0, 0x84, 0x3c, 0x74, 0x8c, 0xe1, 
  0x2c, 0x7a, 0xfc, 0xe4, 0x01, 0x76, 0xfc, 0x35, 0x00, 0x00, 0x7c, 0x5c, 0x04, 0x10, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x09, 0x3d, 0x00, 
};
// -----------[ Public Methods ]-------------------------------------------------
int32_t PWMx8_start(PWMx8 *self, int32_t base, int32_t mask, int32_t freq)
{
  // This method is used to setup the PWM driver and start its cog. If a driver had
  // already been started, it will be stopped first. The arguments are as follows:
  //
  //     base: The base pin of the PWM output block. Must be 0, 8, 16, or 24.
  //
  //     mask: The enable mask for the eight pins in the block:
  //
  //               bit 0 = basepin + 0
  //               bit 1 = basepin + 1
  //               ...
  //               bit 7 = basepin + 7
  //
  //           Set a bit to 1 to enable the corresponding pin for PWM ouput.
  //
  //     freq: The frequency in Hz for the PWM output.
  //
  // Returns true on success; false, if no cog is available or parameters exceed
  // permissible limits.    
  if (self->cogno) {
    PWMx8_stop(self);
  }
  freq = freq * resolution;
  if (((((((CLKFREQ <= 4000000) || (freq > 20648881)) || (CLKFREQ < ((freq * 135) / 10))) || ((CLKFREQ / freq) > 40000)) || (base != (base & 0x18))) || (mask != (mask & 0xff))) || (resolution != (resolution & 0x7ffffffc))) {
    return 0;
  }
  self->basepin = base;
  self->pinmask = mask << base;
  memset( (void *)&self->pwmdata[0], 0, sizeof(int32_t)*nlongs);
  memset( (void *)&self->previndex[0], 0, sizeof(int32_t)*8);
  self->fcb[0] = nlongs;
  self->fcb[1] = freq;
  self->fcb[2] = (0x30000000 | (base << 6)) | mask;
  self->fcb[3] = self->pinmask;
  self->fcb[4] = (int32_t)(&self->pwmdata[0]);
  if ((self->cogno = cognew((int32_t)(&(*(int32_t *)&dat[0])), (int32_t)(&self->fcb[0])) + 1)) {
    return -1;
  } else {
    return 0;
  }
}

int32_t PWMx8_stop(PWMx8 *self)
{
  // This method is used to stop an already-started PWM driver. It returns true if
  // a driver was running; false, otherwise.
  if (self->cogno) {
    cogstop((self->cogno - 1));
    self->cogno = 0;
    return -1;
  } else {
    return 0;
  }
}

int32_t PWMx8_duty(PWMx8 *self, int32_t pinno, int32_t value)
{
  int32_t	vindex, pindex, i, mask, unmask;
  // This method defines a pin's duty cycle. It's arguments are:
  //
  //     pinno: The pin number of the PWM output to modify.
  //
  //     value: The new duty cycle (0 = 0% to resolution = 100%)
  //
  // Returns true on success; false, if pinno or value is invalid.
  if (((((1 << pinno) & self->pinmask) == 0) || (value < 0)) || (value > resolution)) {
    return 0;
  }
  pinno = pinno - self->basepin;
  mask = 16843009 << pinno;
  unmask = ~mask;
  vindex = Shr__(value, 2);
  pindex = self->previndex[pinno];
  if (vindex > pindex) {
    {
      int32_t _limit__0080 = (vindex - 1);
      int32_t _step__0081 = 1;
      i = pindex;
      if (i >= _limit__0080) _step__0081 = -_step__0081;
      do {
        self->pwmdata[i] = self->pwmdata[i] | mask;
        i = i + _step__0081;
      } while (((_step__0081 > 0) && (i <= _limit__0080)) || ((_step__0081 < 0) && (i >= _limit__0080)));
    }
  } else {
    if (vindex < pindex) {
      {
        int32_t _limit__0082 = (vindex + 1);
        int32_t _step__0083 = 1;
        i = pindex;
        if (i >= _limit__0082) _step__0083 = -_step__0083;
        do {
          self->pwmdata[i] = self->pwmdata[i] & unmask;
          i = i + _step__0083;
        } while (((_step__0083 > 0) && (i <= _limit__0082)) || ((_step__0083 < 0) && (i >= _limit__0082)));
      }
    }
  }
  self->pwmdata[vindex] = (self->pwmdata[vindex] & unmask) | (mask & (Shr__((Shr__(-1, (31 - ((value & 0x3) << 3)))), 1)));
  self->previndex[pinno] = vindex;
  return -1;
}

// -----------[ TERMS OF USE ]---------------------------------------------------
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the
// Software, and to permit persons to whom the Software is furnished to do so,
// subject to the following conditions: 
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software. 
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
