//
// automatically generated by spin2cpp v1.94 on Sun Sep 25 16:00:57 2016
// C:\Users\Dave\Desktop\s3_spin\temp\spin2cpp.exe --ccode scribbler_test.spin 
//

// :::::::[ Driver Object for the Scribbler Robot Models S2 & S3 ]:::::::::::::::::::::::::::::::::
/* {
+---------------------------------------+
|          Scribbler Object             |
|(c) Copyright 2010 Bueno Systems, Inc. |
|   See end of file for terms of use.   |
+---------------------------------------+
This object provides both high- and low-level drivers for the
Parallax Scribbler S2 & S3 robots.

Version History
---------------

2010.09.16: Initial Version 1(M) release
2010.09.28: Version 1(N) release:
              Fixed bug in _ee* Spin routines.
              Upped size of sound buffer to 1200.
              Added calibration methods for light sensors.
              Added 1/2 sec. delay to start routine.
2010.10.18:   Added check for zero time in play_tone.
2010.10.25:   Added log response method for light sensors.
2010.10.27: Version 1(O) release:
              Added methods to save default line sensor threshold.
2010.10.28:   Fixed bugs in calibration methods.
2010.11.15: Version 1(P) release:
              Added self-documentation features.
              Added sensitivity setting for obstacle detection.

2015.03.11: Ben Wirz - modified the original S2 object to suport both the S2 & S3
              Renamed to the scribbler object from the S2 object.
              Added support for detecting the hardware model number.
              Added support for the S3's different EEPROM type and layout.
              Added basic support for controlling the battery charger IC.
              
                            
 */
/* =======[ Introduction ]=========================================================

scribbler.spin provides low-level drivers for the Scribblers's various functions, as
well as top-level access functions to interface with those drivers. Driver functions
are separated into four additional cogs:
''
''  1. Analog, button, and LED drivers.
''  2. Motor driver.
''  3. Sound sequencer and synthesizer.
''  4. Microphone envelope detector.
''
Driver #1 is required and is started with the scribbler object's main `start method.
The other drivers are optional, depending upon the user's requirements, and have their
own start methods (`start_motors, `start_tones, `start_mic_env). The scribbler object's
`stop method stops all driver cogs which have been started.

The analog, button, and LED drivers are the heartbeat of the system. The analog
driver continuously cycles through sixteen analog inputs and updates their states
with a one-millisecond cycle time. The button driver monitors the state
of the scribblers's single pushbutton and, depending on the user-selected button mode, can
cause it to reset the scribbler, while displaying the button-press count on the LEDs, and
record the number of button presses in EEPROM for use by the newly-restarted user
program. The LED driver manages the LEDs' polarity and PWMing to provide various
shades and hues from the scribbler's red/green LEDs and blue power LED. It doesn this via
the LEDs' shift register port.

 */
// =======[ Constants... ]=========================================================
#include <stdlib.h>
#include <propeller.h>
#include "scribbler.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define Yield__() __asm__ volatile( "" ::: "memory" )
#define BitEncode__(X) (32 - __builtin_clz(X))
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#define Yield__()
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
INLINE__ int32_t BitEncode__(uint32_t a) {
  int r=0;
  while (a != 0) { a = a>>1; r++; }
  return r;
}
#endif

INLINE__ int32_t Min__(int32_t a, int32_t b) { return a < b ? a : b; }
INLINE__ int32_t Max__(int32_t a, int32_t b) { return a > b ? a : b; }
INLINE__ int32_t Shr__(uint32_t a, uint32_t b) { return (a>>b); }
INLINE__ int32_t Lookdown__(int32_t x, int32_t b, int32_t a[], int32_t n) { int32_t i, r; r = 0; for (i = 0; i < n; i++) { if (a[i] == x) { r = i+b; break; } }; return r; }

static uint32_t Sqrt__(uint32_t a) {
    uint32_t res = 0;
    uint32_t bit = 1<<30;
    while (bit > a) bit = bit>>2;
    while (bit != 0) {
        if (a >= res+bit) {
            a = a - (res+bit);
            res = (res>>1) + bit;
        } else res = res >> 1;
        bit = bit >> 2;
    }
    return res;
}
static  int32_t scribbler__compute_calibration(void);
static  int32_t scribbler__atan2(int32_t y, int32_t x);
static  int32_t scribbler__enqueue_tone(int32_t tone_word);
static  int32_t scribbler__i2c_rd(int32_t acknak);
static  int32_t scribbler__i2c_wr(int32_t data);
static  int32_t scribbler__i2c_start(void);
static  int32_t scribbler__i2c_stop(void);
static  int32_t scribbler__ee_rdblock(scribbler *self, int32_t dest_addr, int32_t addr, int32_t size);
static  int32_t scribbler__ee_wrblock(scribbler *self, int32_t src_addr, int32_t addr, int32_t size);
static  int32_t scribbler__ee_rdbyte(scribbler *self, int32_t addr);
static  int32_t scribbler__ee_wrbyte(scribbler *self, int32_t addr, int32_t data);
static  int32_t scribbler__ee_waddr(int32_t addr);
static  int32_t scribbler__BQ2495_rdbyte(scribbler *self, int32_t addr);
static  int32_t scribbler__BQ2495_wrbyte(scribbler *self, int32_t addr, int32_t data);
static  int32_t scribbler__BQ2495_waddr(int32_t addr);

static uint8_t dat[] = {
  0x1b, 0xf0, 0xbf, 0xa0, 0x1a, 0xec, 0xbf, 0xa0, 0x01, 0xf4, 0xff, 0xa0, 0x19, 0x38, 0xbc, 0xa0, 
  0x01, 0x38, 0xfc, 0x28, 0xf1, 0x3f, 0xbc, 0xa0, 0x19, 0x3e, 0xbc, 0x80, 0xfc, 0x41, 0xbc, 0xa0, 
  0x00, 0x3a, 0xfc, 0xa0, 0x18, 0x3c, 0xbc, 0xa0, 0x0f, 0x2e, 0xfc, 0x5c, 0x21, 0x3a, 0xbc, 0x88, 
  0x0a, 0x3c, 0xfc, 0xe4, 0xf0, 0x3b, 0x3c, 0x08, 0x08, 0x00, 0x7c, 0x5c, 0x19, 0x3e, 0xbc, 0xf8, 
  0xfc, 0x43, 0xbc, 0xa0, 0x20, 0x42, 0xbc, 0x84, 0x21, 0x40, 0xbc, 0x80, 0x1c, 0x42, 0xbc, 0x84, 
  0x04, 0x38, 0xfc, 0x2c, 0x21, 0x38, 0xbc, 0x80, 0x04, 0x38, 0xfc, 0x28, 0x00, 0x00, 0x7c, 0x5c, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x0a, 0x12, 0x00, 0x24, 
  0x8a, 0xf0, 0xbf, 0xa0, 0x89, 0x50, 0xbd, 0xa0, 0x95, 0x50, 0xbd, 0x80, 0x95, 0x50, 0xbd, 0x80, 
  0xa8, 0x2c, 0xbd, 0xa0, 0x02, 0x50, 0xfd, 0x80, 0xa8, 0x2e, 0xbd, 0xa0, 0x02, 0x50, 0xfd, 0x80, 
  0xa8, 0x30, 0xbd, 0xa0, 0x01, 0x50, 0xfd, 0x80, 0xa8, 0x32, 0xbd, 0xa0, 0xf1, 0x4b, 0xbd, 0xa0, 
  0x88, 0x4a, 0xbd, 0x80, 0x61, 0xf8, 0xfc, 0x5c, 0xa8, 0x4e, 0xbd, 0xa0, 0x8f, 0x50, 0xbd, 0x60, 
  0x0d, 0x4e, 0xfd, 0x2a, 0x1e, 0x00, 0x68, 0x5c, 0x01, 0x4e, 0x7d, 0x86, 0x17, 0x00, 0x54, 0x5c, 
  0x03, 0x50, 0xfd, 0x2c, 0xa8, 0x26, 0xbd, 0xa0, 0x0d, 0x00, 0x7c, 0x5c, 0x02, 0x4e, 0x7d, 0x86, 
  0x1c, 0x00, 0x68, 0x5c, 0x03, 0x4e, 0x7d, 0x86, 0x0d, 0x00, 0x54, 0x5c, 0x00, 0x28, 0xfd, 0xa0, 
  0x99, 0x50, 0x3d, 0x00, 0x0d, 0x00, 0x7c, 0x5c, 0xa8, 0x48, 0xbd, 0xa0, 0x06, 0x50, 0xfd, 0x2c, 
  0xa8, 0x48, 0xbd, 0x80, 0x01, 0x48, 0xfd, 0x28, 0x61, 0xf8, 0xfc, 0x5c, 0xa8, 0x3e, 0xbd, 0xa0, 
  0x12, 0x3e, 0xfd, 0x2e, 0x01, 0x3e, 0xfd, 0x28, 0x00, 0x38, 0xe9, 0xa0, 0xa8, 0x42, 0xbd, 0xa0, 
  0x0e, 0x42, 0xfd, 0x28, 0x61, 0xf8, 0xfc, 0x5c, 0xa8, 0x40, 0xbd, 0xa0, 0x12, 0x40, 0xfd, 0x2e, 
  0x01, 0x40, 0xfd, 0x28, 0x00, 0x3a, 0xe9, 0xa0, 0xa8, 0x44, 0xbd, 0xa0, 0x0e, 0x44, 0xfd, 0x28, 
  0x8b, 0xec, 0xbf, 0x68, 0x98, 0x50, 0xbd, 0x00, 0x01, 0x50, 0x7d, 0x86, 0x0d, 0x00, 0x68, 0x5c, 
  0x9f, 0x38, 0xbd, 0x80, 0xa0, 0x3a, 0xbd, 0x80, 0x9c, 0x3c, 0xbd, 0xa0, 0xa1, 0x46, 0xbd, 0xa0, 
  0x48, 0xc0, 0xfc, 0x5c, 0xa8, 0x4c, 0xbd, 0xa0, 0x9d, 0x3c, 0xbd, 0xa0, 0xa2, 0x46, 0xbd, 0xa0, 
  0x48, 0xc0, 0xfc, 0x5c, 0xa8, 0x4c, 0xbd, 0x80, 0xa6, 0x50, 0xbd, 0xa8, 0x93, 0x52, 0xbd, 0xa0, 
  0x7d, 0x0e, 0xfd, 0x5c, 0x01, 0x4c, 0xfd, 0x2d, 0x8d, 0x4c, 0xbd, 0xa0, 0xa8, 0x4c, 0xbd, 0x90, 
  0x88, 0x4a, 0xbd, 0xf8, 0xa6, 0xf4, 0xbf, 0xa0, 0x31, 0x48, 0xfd, 0xe4, 0x0d, 0x00, 0x7c, 0x5c, 
  0x02, 0x46, 0x7d, 0x61, 0x01, 0x46, 0x7d, 0x62, 0x53, 0x00, 0x70, 0x5c, 0x4f, 0x00, 0x54, 0x5c, 
  0x01, 0x3c, 0x7d, 0x2d, 0x8e, 0x50, 0xbd, 0xb0, 0x60, 0x00, 0x3c, 0x5c, 0x9e, 0x50, 0xbd, 0xa0, 
  0x8d, 0x50, 0xbd, 0x80, 0x01, 0x50, 0xfd, 0x38, 0x60, 0x00, 0x3c, 0x5c, 0x57, 0x00, 0x54, 0x5c, 
  0x9e, 0x50, 0xbd, 0xa8, 0x8e, 0x50, 0xbd, 0x84, 0x60, 0x00, 0x3c, 0x5c, 0x13, 0x3c, 0xfd, 0x28, 
  0x90, 0x3c, 0x3d, 0x62, 0x91, 0x3c, 0x3d, 0x61, 0x9e, 0x3c, 0xbd, 0xb0, 0x92, 0x3c, 0xbd, 0x68, 
  0x01, 0x3c, 0xfd, 0x2c, 0x9e, 0x50, 0xbd, 0x04, 0xa8, 0x50, 0xbd, 0xbc, 0x0e, 0x50, 0xfd, 0x2c, 
  0x00, 0x00, 0x7c, 0x5c, 0x98, 0x50, 0xbd, 0x00, 0x02, 0x50, 0x7d, 0x86, 0x01, 0x50, 0x55, 0x86, 
  0x00, 0x28, 0xe9, 0xa0, 0x68, 0x00, 0x68, 0x5c, 0x03, 0x50, 0x7d, 0x86, 0x01, 0x28, 0xe9, 0xa0, 
  0x98, 0x18, 0x29, 0x00, 0x94, 0x28, 0x3d, 0x62, 0x6f, 0x00, 0x68, 0x5c, 0x96, 0x34, 0xbd, 0x04, 
  0x97, 0x36, 0xbd, 0x04, 0x9b, 0x34, 0x3d, 0x86, 0x74, 0x00, 0x54, 0x5c, 0xff, 0xf5, 0xff, 0xe1, 
  0x8b, 0xec, 0x8f, 0x64, 0xf1, 0x4b, 0xbd, 0xa0, 0x88, 0x4a, 0xbd, 0x80, 0x61, 0x00, 0x7c, 0x5c, 
  0x01, 0x36, 0xfd, 0x2c, 0x89, 0x36, 0xbd, 0x80, 0x9b, 0x50, 0xbd, 0x04, 0x89, 0x36, 0xbd, 0x84, 
  0x01, 0x36, 0xfd, 0x28, 0x01, 0x36, 0xfd, 0x80, 0x95, 0x36, 0xbd, 0xe0, 0x97, 0x36, 0x3d, 0x04, 
  0x00, 0x00, 0x7c, 0x5c, 0x00, 0x54, 0xfd, 0xa0, 0x20, 0x56, 0xfd, 0xa0, 0x01, 0x50, 0xfd, 0x29, 
  0xa9, 0x54, 0xb1, 0x81, 0x01, 0x54, 0xfd, 0x31, 0x01, 0x50, 0xfd, 0x31, 0x80, 0x56, 0xfd, 0xe4, 
  0x10, 0x50, 0xfd, 0x28, 0x10, 0x54, 0xfd, 0x2c, 0xaa, 0x50, 0xbd, 0x68, 0x00, 0x00, 0x7c, 0x5c, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x15, 0x00, 0x00, 0x18, 0x00, 0x00, 0x20, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xff, 0xff, 0xff, 0x3f, 0xff, 0x1f, 0x00, 0x00, 
  0x00, 0x10, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x70, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x20, 0x03, 0x00, 0x00, 0x08, 0xf1, 0xbf, 0xa0, 0x09, 0xed, 0xbf, 0xa0, 
  0x01, 0xf4, 0xff, 0xa0, 0xf0, 0x55, 0xbe, 0xa0, 0x02, 0x54, 0xfe, 0x28, 0x09, 0x54, 0x7e, 0xe8, 
  0xa2, 0x62, 0xfe, 0xa0, 0x1a, 0x61, 0xbe, 0xa0, 0x0b, 0x00, 0x7c, 0x5c, 0xa0, 0x62, 0xfe, 0xa0, 
  0x1b, 0x61, 0xbe, 0xa0, 0x27, 0x3d, 0xfc, 0x54, 0x26, 0x3f, 0xfc, 0x54, 0x07, 0x2c, 0xfc, 0x50, 
  0x02, 0x58, 0xfe, 0xa0, 0x0f, 0x3f, 0xbe, 0xa0, 0x0e, 0x49, 0xbe, 0xa0, 0x0e, 0x4b, 0xbe, 0xa0, 
  0x01, 0x4a, 0xfe, 0x28, 0x04, 0x38, 0xfe, 0xa0, 0xc1, 0xa2, 0xfd, 0x5c, 0x2a, 0x47, 0xbe, 0xa0, 
  0x00, 0x38, 0xfe, 0xa0, 0xc1, 0xa2, 0xfd, 0x5c, 0x23, 0x55, 0xbe, 0x84, 0xff, 0x54, 0x7e, 0xc3, 
  0x1e, 0x00, 0x68, 0x5c, 0x25, 0x49, 0xbe, 0x94, 0x01, 0x4a, 0xfe, 0x2a, 0x13, 0x00, 0x54, 0x5c, 
  0x24, 0x01, 0xbc, 0xa0, 0x23, 0x01, 0xbc, 0xa0, 0x29, 0x3d, 0xfc, 0x54, 0x28, 0x3f, 0xfc, 0x54, 
  0x06, 0x2c, 0xfc, 0x50, 0x10, 0x58, 0xfe, 0xe4, 0xf1, 0x43, 0xbe, 0xa0, 0x0f, 0x43, 0xbe, 0x80, 
  0x0f, 0x43, 0xbe, 0xf8, 0x17, 0x3d, 0xbe, 0xa0, 0x28, 0x3c, 0xfe, 0x80, 0x1e, 0x55, 0xbe, 0x08, 
  0x01, 0x54, 0xfe, 0x80, 0x1e, 0x55, 0x3e, 0x08, 0x18, 0x3b, 0xbe, 0xa0, 0x01, 0x5a, 0xfe, 0x80, 
  0x1d, 0x55, 0xbe, 0x06, 0x5f, 0x00, 0x68, 0x5c, 0x02, 0x3a, 0xfe, 0x80, 0x2a, 0x39, 0xbe, 0xa0, 
  0x0c, 0x38, 0xfe, 0x28, 0x2a, 0x3d, 0xbe, 0xa0, 0x07, 0x3c, 0xfe, 0x28, 0x1e, 0x3c, 0xfe, 0x60, 
  0x17, 0x3d, 0xbe, 0x80, 0x2a, 0x59, 0xbe, 0xa0, 0x04, 0x58, 0xfe, 0x28, 0x0f, 0x58, 0xfe, 0x60, 
  0x50, 0x3e, 0xfe, 0xa0, 0x2c, 0x3f, 0xbe, 0x2c, 0x2a, 0x41, 0xbe, 0xa0, 0x01, 0x40, 0xfe, 0x28, 
  0x07, 0x40, 0xfe, 0x60, 0xba, 0xa2, 0xfd, 0x5c, 0x03, 0x38, 0x7e, 0x86, 0x49, 0x00, 0x54, 0x5c, 
  0x2a, 0x57, 0xbe, 0xa0, 0x0a, 0xe9, 0xbf, 0x68, 0x01, 0x54, 0xfe, 0x64, 0xba, 0xa2, 0xfd, 0x5c, 
  0x0a, 0xe9, 0xbf, 0x64, 0x2b, 0x55, 0xbe, 0x84, 0x00, 0x54, 0xfe, 0x40, 0x1e, 0x59, 0xbe, 0x04, 
  0x2c, 0x57, 0xbe, 0xa0, 0x20, 0x57, 0xbe, 0x28, 0x2b, 0x59, 0xbe, 0x84, 0x08, 0x54, 0xfe, 0x2c, 
  0x20, 0x55, 0xbe, 0x28, 0x2a, 0x59, 0xbe, 0x80, 0x1e, 0x59, 0x3e, 0x04, 0x2e, 0x00, 0x54, 0x5c, 
  0x08, 0x58, 0xfe, 0x28, 0x01, 0x2c, 0x7e, 0x62, 0x0a, 0x54, 0xd6, 0xa0, 0x0f, 0x54, 0xea, 0xa0, 
  0x2a, 0x59, 0x3e, 0x85, 0x01, 0x2c, 0xfe, 0x74, 0x2e, 0x00, 0x64, 0x5c, 0x17, 0x3d, 0xbe, 0xa0, 
  0x20, 0x3c, 0xfe, 0x80, 0x1e, 0x59, 0xbe, 0x04, 0x01, 0x58, 0xfe, 0x80, 0x1e, 0x59, 0x3e, 0x04, 
  0x2e, 0x00, 0x7c, 0x5c, 0x17, 0x3d, 0xbe, 0xa0, 0x2d, 0x3c, 0xfe, 0x80, 0x1e, 0x5d, 0xbe, 0x00, 
  0xf2, 0x25, 0x3e, 0x61, 0x10, 0x2b, 0x8e, 0xa0, 0x01, 0x28, 0xfe, 0x36, 0x01, 0x26, 0x7e, 0x61, 
  0x01, 0x28, 0x72, 0x82, 0x01, 0x26, 0xea, 0x80, 0x13, 0x57, 0xbe, 0xa0, 0x01, 0x56, 0xfe, 0x2a, 
  0x08, 0x56, 0xfe, 0x4c, 0x01, 0x2a, 0xfe, 0xe1, 0x80, 0x00, 0x78, 0x5c, 0x01, 0x3c, 0xfe, 0x84, 
  0x1e, 0x57, 0x3e, 0x00, 0x00, 0x26, 0xfe, 0xa0, 0x02, 0x5c, 0x7e, 0x61, 0x80, 0x00, 0x4c, 0x5c, 
  0x01, 0x54, 0xfe, 0x0c, 0x07, 0x58, 0xfe, 0xa0, 0x2c, 0x55, 0x3e, 0x86, 0x03, 0x58, 0x56, 0x0c, 
  0x01, 0x58, 0xfe, 0x85, 0x74, 0x00, 0x4c, 0x5c, 0x00, 0x5e, 0xfe, 0xa0, 0xd2, 0xb8, 0xfd, 0x5c, 
  0x2b, 0x55, 0xbe, 0xa0, 0xe2, 0xde, 0xfd, 0x5c, 0xfa, 0x06, 0xfe, 0x5c, 0x00, 0x4a, 0xfe, 0xa0, 
  0xb2, 0x72, 0xfd, 0x5c, 0x00, 0x22, 0x7e, 0x0c, 0x01, 0x5c, 0x7e, 0x61, 0x92, 0x00, 0x6c, 0x5c, 
  0x19, 0x55, 0xbe, 0xa0, 0x2b, 0x55, 0xbe, 0x28, 0x2b, 0x55, 0xbe, 0x28, 0x00, 0x4a, 0xfe, 0xa0, 
  0x06, 0x58, 0xfe, 0xa0, 0x10, 0x48, 0xfe, 0xa0, 0x01, 0x54, 0xfe, 0x29, 0x24, 0x4b, 0xbe, 0x70, 
  0x20, 0x48, 0x7e, 0x61, 0x1f, 0x48, 0xfe, 0x60, 0x01, 0x48, 0xfe, 0x34, 0x88, 0x58, 0xfe, 0xe4, 
  0x40, 0x5a, 0x7e, 0x61, 0x02, 0x5c, 0x7e, 0x62, 0x80, 0x4a, 0xd6, 0x70, 0xb0, 0x00, 0x7c, 0x5c, 
  0x17, 0x3d, 0xbe, 0xa0, 0x24, 0x3c, 0xfe, 0x80, 0x04, 0x58, 0xfe, 0xa0, 0x2d, 0x49, 0xbe, 0xa0, 
  0x0f, 0x48, 0xfe, 0x60, 0x01, 0x48, 0xfe, 0x80, 0x1e, 0x55, 0xbe, 0x00, 0x01, 0x3c, 0xfe, 0x80, 
  0x2a, 0x57, 0xbe, 0xa0, 0x04, 0x56, 0xfe, 0x28, 0x0f, 0x54, 0xfe, 0x60, 0x2a, 0x3f, 0xbe, 0xa0, 
  0x2b, 0x3f, 0xbe, 0x80, 0x10, 0x3e, 0x7e, 0x85, 0x00, 0x5b, 0x4e, 0x62, 0x00, 0x54, 0xca, 0xa0, 
  0x00, 0x56, 0xc6, 0xa0, 0x01, 0x54, 0x7e, 0x86, 0x00, 0x54, 0xea, 0xa0, 0x01, 0x56, 0x7e, 0x86, 
  0x00, 0x56, 0xea, 0xa0, 0x2a, 0x3f, 0xbe, 0xa0, 0x2b, 0x3f, 0xbe, 0x80, 0x02, 0x4a, 0xfe, 0x2c, 
  0x24, 0x3f, 0x3e, 0x85, 0xaf, 0x00, 0x70, 0x5c, 0x24, 0x55, 0x3e, 0x85, 0x01, 0x4a, 0xce, 0x68, 
  0x02, 0x4a, 0xf2, 0x68, 0x98, 0x58, 0xfe, 0xe4, 0xb2, 0x72, 0xfd, 0x5c, 0x26, 0x00, 0x7c, 0x5c, 
  0x08, 0x58, 0xfe, 0xa0, 0x01, 0x4a, 0xfe, 0x29, 0x80, 0xe8, 0xff, 0x70, 0x00, 0xe9, 0xff, 0x68, 
  0x00, 0xe9, 0xff, 0x64, 0xb3, 0x58, 0xfe, 0xe4, 0x80, 0xe8, 0xff, 0x64, 0x00, 0x00, 0x7c, 0x5c, 
  0x01, 0x54, 0x7e, 0x61, 0x26, 0x47, 0x8e, 0xa0, 0x27, 0x49, 0x8e, 0xa0, 0x28, 0x47, 0xb2, 0xa0, 
  0x29, 0x49, 0xb2, 0xa0, 0x01, 0x7e, 0x7d, 0x61, 0xc2, 0x00, 0x7c, 0x5c, 0x00, 0x82, 0x7d, 0x61, 
  0x16, 0x38, 0xfe, 0x2c, 0xf4, 0x55, 0xbe, 0xa0, 0x0b, 0x55, 0xbe, 0x64, 0x1c, 0x55, 0xbe, 0x68, 
  0x2a, 0xe9, 0xbf, 0xa0, 0x16, 0x38, 0xfe, 0x28, 0xf1, 0x45, 0xbe, 0xa0, 0x1f, 0x45, 0xbe, 0x80, 
  0x24, 0x45, 0xbe, 0xf8, 0xfc, 0x55, 0xbe, 0xa4, 0x00, 0x44, 0xfe, 0xf8, 0xfc, 0x55, 0xbe, 0x80, 
  0x23, 0x55, 0xb2, 0x84, 0x00, 0x54, 0xf2, 0x40, 0xff, 0x54, 0xf2, 0x44, 0x00, 0x00, 0x7c, 0x5c, 
  0x30, 0x5f, 0xbe, 0x80, 0xf0, 0xf2, 0xfd, 0x5c, 0x31, 0x55, 0xbe, 0xa0, 0xe2, 0xde, 0xfd, 0x5c, 
  0xd2, 0x00, 0x70, 0x5c, 0x2f, 0x55, 0xbe, 0xa0, 0x08, 0x54, 0xfe, 0x28, 0xe2, 0xde, 0xfd, 0x5c, 
  0x2f, 0x55, 0xbe, 0xa0, 0xe2, 0xde, 0xfd, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 0x01, 0xba, 0x7d, 0x61, 
  0xe0, 0x00, 0x7c, 0x5c, 0x00, 0xbe, 0x7d, 0x61, 0xff, 0x54, 0xfe, 0xa0, 0xe3, 0x00, 0x7c, 0x5c, 
  0x01, 0xc4, 0x7d, 0x61, 0x09, 0x58, 0xfe, 0xa0, 0x18, 0x54, 0xfe, 0x34, 0x01, 0x54, 0xfe, 0x35, 
  0x0d, 0xed, 0xbf, 0x74, 0x04, 0x0f, 0xfe, 0x5c, 0x0c, 0xe9, 0xbf, 0x68, 0x04, 0x0f, 0xfe, 0x5c, 
  0xf2, 0x1b, 0x3e, 0x61, 0x0c, 0xe9, 0xbf, 0x64, 0x04, 0x0f, 0xfe, 0x5c, 0xe5, 0x58, 0xfe, 0xe4, 
  0xff, 0x54, 0xfe, 0x60, 0x00, 0x00, 0x7c, 0x5c, 0x0d, 0xed, 0xbf, 0x64, 0x04, 0x0f, 0xfe, 0x5c, 
  0x0c, 0xe9, 0xbf, 0x68, 0x0c, 0xed, 0xbf, 0x68, 0x04, 0x0f, 0xfe, 0x5c, 0x0d, 0xed, 0xbf, 0x68, 
  0x04, 0x0f, 0xfe, 0x5c, 0x0c, 0xe9, 0xbf, 0x64, 0x04, 0x0f, 0xfe, 0x5c, 0x00, 0x00, 0x7c, 0x5c, 
  0x0c, 0xe9, 0xbf, 0x64, 0x04, 0x0f, 0xfe, 0x5c, 0x0d, 0xed, 0xbf, 0x68, 0x04, 0x0f, 0xfe, 0x5c, 
  0x0c, 0xe9, 0xbf, 0x68, 0x04, 0x0f, 0xfe, 0x5c, 0x0d, 0xed, 0xbf, 0x64, 0x04, 0x0f, 0xfe, 0x5c, 
  0x0c, 0xed, 0xbf, 0x64, 0x00, 0x00, 0x7c, 0x5c, 0x34, 0x44, 0xfe, 0xa0, 0xf1, 0x45, 0xbe, 0x80, 
  0x00, 0x44, 0xfe, 0xf8, 0x00, 0x00, 0x7c, 0x5c, 0x1b, 0x34, 0x00, 0x24, 0x80, 0x11, 0xc0, 0x07, 
  0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x03, 0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x20, 
  0x00, 0x08, 0x00, 0x00, 0x80, 0x38, 0x01, 0x00, 0xe8, 0x03, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 
  0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0xa5, 0x02, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0xfc, 0xec, 0xbf, 0xa0, 0x01, 0xf4, 0xff, 0xa0, 
  0x01, 0xf6, 0xff, 0xa0, 0xf0, 0x11, 0xbe, 0xa0, 0x04, 0x10, 0xfe, 0x80, 0xf0, 0x13, 0xbe, 0xa0, 
  0x08, 0x12, 0xfe, 0x80, 0xf1, 0x05, 0xbe, 0xa0, 0x00, 0x05, 0xbe, 0x80, 0xf2, 0xf5, 0x3d, 0x61, 
  0x01, 0x20, 0xfe, 0x34, 0xf2, 0xf7, 0x3d, 0x61, 0x01, 0x22, 0xfe, 0x34, 0x00, 0x44, 0xfe, 0xa0, 
  0xb7, 0x96, 0xfd, 0x5c, 0xf0, 0x07, 0x3e, 0x08, 0xf0, 0x1b, 0xbe, 0x0a, 0x17, 0x00, 0x54, 0x5c, 
  0x00, 0xf0, 0xff, 0xa0, 0x00, 0xf2, 0xff, 0xa0, 0xb7, 0x96, 0xfd, 0x5c, 0xf0, 0x1b, 0xbe, 0x0a, 
  0x15, 0x00, 0x68, 0x5c, 0x0d, 0x1d, 0xbe, 0xa0, 0x10, 0x1c, 0xfe, 0x2a, 0x04, 0x1a, 0xd6, 0x7c, 
  0x0d, 0x31, 0xbe, 0xa0, 0x08, 0x30, 0xfe, 0x28, 0x0f, 0x30, 0xfe, 0x60, 0x0d, 0x33, 0xbe, 0xa0, 
  0x04, 0x32, 0xfe, 0x28, 0x0f, 0x32, 0xfe, 0x60, 0x08, 0x32, 0xfe, 0x48, 0x0f, 0x1a, 0xfe, 0x60, 
  0x08, 0x25, 0xbe, 0x0a, 0xf0, 0x07, 0x3e, 0x08, 0x12, 0x00, 0x68, 0x5c, 0xf4, 0x17, 0xbe, 0xa0, 
  0x12, 0x27, 0xbe, 0xa0, 0x10, 0x26, 0xfe, 0x38, 0x10, 0x24, 0xfe, 0x2c, 0x10, 0x24, 0xfe, 0x38, 
  0x12, 0x25, 0xbe, 0xa9, 0xf7, 0x16, 0x8e, 0x6c, 0x01, 0x24, 0xfe, 0x2c, 0x01, 0x24, 0xfe, 0x48, 
  0xf7, 0xe8, 0xbf, 0x74, 0x13, 0x27, 0xbe, 0xa9, 0xf8, 0x16, 0x8e, 0x6c, 0x01, 0x26, 0xfe, 0x2c, 
  0x01, 0x26, 0xfe, 0x48, 0xf8, 0xe8, 0xbf, 0x74, 0xf9, 0x16, 0x3e, 0x62, 0xe7, 0xde, 0xd5, 0x5c, 
  0x13, 0x29, 0xbe, 0xa0, 0x12, 0x29, 0xbe, 0x48, 0x00, 0x2e, 0xfe, 0xa0, 0x13, 0x15, 0xbe, 0xa0, 
  0x12, 0x17, 0xbe, 0xa0, 0xf0, 0xec, 0xfd, 0x5c, 0x0a, 0x2b, 0xbe, 0xa0, 0x0a, 0x2d, 0xbe, 0xa0, 
  0x12, 0x27, 0x3e, 0x85, 0x01, 0x40, 0xf2, 0xa0, 0x00, 0x42, 0xf2, 0xa0, 0x01, 0x42, 0xce, 0xa0, 
  0x00, 0x40, 0xce, 0xa0, 0x00, 0xf8, 0xff, 0xa0, 0x00, 0xfa, 0xff, 0xa0, 0xfd, 0xf0, 0xbf, 0xa0, 
  0xfe, 0xf2, 0xbf, 0xa0, 0xf1, 0x05, 0xbe, 0xa0, 0x00, 0x05, 0xbe, 0x80, 0x01, 0x1f, 0xbe, 0xa0, 
  0x01, 0x4e, 0xfe, 0xa0, 0xb9, 0x96, 0xfd, 0x5c, 0x05, 0x3f, 0xbe, 0x04, 0x51, 0x0c, 0x7e, 0xe8, 
  0x00, 0x3a, 0xfe, 0xa0, 0x00, 0x38, 0xfe, 0xa0, 0x05, 0x0c, 0xfe, 0xa0, 0x54, 0x0e, 0x7e, 0xe8, 
  0x90, 0x0f, 0xfe, 0xa0, 0x00, 0x3c, 0xfe, 0xa0, 0xf0, 0x15, 0xbe, 0x08, 0x01, 0x14, 0x7e, 0x62, 
  0x15, 0x00, 0x54, 0x5c, 0x0f, 0x36, 0xfe, 0xa0, 0x04, 0x1a, 0x7e, 0x62, 0x61, 0x00, 0x68, 0x5c, 
  0x61, 0x1e, 0xfe, 0xe4, 0x01, 0x1f, 0xbe, 0xa0, 0x01, 0x1c, 0xfe, 0x86, 0x10, 0x00, 0x68, 0x5c, 
  0x0e, 0x15, 0xbe, 0xa0, 0x04, 0x14, 0xfe, 0x28, 0x0a, 0x37, 0xbe, 0x4c, 0x02, 0x1a, 0x7e, 0x62, 
  0x68, 0x00, 0x68, 0x5c, 0xff, 0x2a, 0x3e, 0x87, 0xff, 0x2c, 0x3a, 0x87, 0xff, 0x2a, 0xba, 0x80, 
  0xff, 0x2c, 0xba, 0x80, 0x6d, 0x00, 0x7c, 0x5c, 0x14, 0x15, 0xbe, 0xa0, 0x17, 0x15, 0xbe, 0x84, 
  0x03, 0x14, 0xfe, 0x28, 0x19, 0x15, 0xbe, 0x48, 0x0a, 0x37, 0xbe, 0x4c, 0x17, 0x15, 0xbe, 0xa0, 
  0x02, 0x14, 0xfe, 0x28, 0x01, 0x34, 0xfe, 0x80, 0x1a, 0x15, 0xbe, 0x48, 0x01, 0x34, 0xfe, 0x84, 
  0x0a, 0x37, 0xbe, 0x4c, 0x18, 0x37, 0xbe, 0x4c, 0x02, 0x36, 0xfe, 0x48, 0xf2, 0xf5, 0x3d, 0x61, 
  0x01, 0x20, 0xfe, 0x34, 0x03, 0x20, 0x7e, 0x61, 0x01, 0x38, 0xf2, 0x80, 0x13, 0x2b, 0xb2, 0xe2, 
  0x20, 0x3d, 0xb2, 0x80, 0x20, 0x2f, 0xb2, 0x80, 0x00, 0xf0, 0xe3, 0xa0, 0xf2, 0xf7, 0x3d, 0x61, 
  0x01, 0x22, 0xfe, 0x34, 0x03, 0x22, 0x7e, 0x61, 0x01, 0x3a, 0xf2, 0x80, 0x12, 0x2d, 0xb2, 0xe2, 
  0x21, 0x3d, 0xb2, 0x80, 0x21, 0x2f, 0xb2, 0x80, 0x00, 0xf2, 0xe3, 0xa0, 0x14, 0x2f, 0xbe, 0x4c, 
  0x22, 0x47, 0xbe, 0xa0, 0x22, 0x49, 0xbe, 0xa0, 0x16, 0x2b, 0x3e, 0x87, 0x96, 0x00, 0x68, 0x5c, 
  0x91, 0x00, 0x4c, 0x5c, 0x16, 0x15, 0xbe, 0xa0, 0x12, 0x15, 0xbe, 0x84, 0x13, 0x25, 0x3e, 0x87, 
  0x0a, 0x2b, 0x06, 0x85, 0x00, 0x46, 0xfa, 0xa0, 0x96, 0x00, 0x7c, 0x5c, 0x15, 0x15, 0xbe, 0xa0, 
  0x13, 0x15, 0xbe, 0x84, 0x12, 0x27, 0x3e, 0x87, 0x0a, 0x2d, 0x06, 0x85, 0x00, 0x48, 0xfa, 0xa0, 
  0xcc, 0xcc, 0xfd, 0x5c, 0x16, 0x2b, 0x3e, 0x6a, 0x10, 0x00, 0x68, 0x5c, 0x00, 0x05, 0xbe, 0xf8, 
  0x23, 0xf9, 0xbf, 0xa4, 0x24, 0xfb, 0xbf, 0xa4, 0x4d, 0x0e, 0xfe, 0xe4, 0x1e, 0x35, 0xbe, 0xa0, 
  0x1b, 0x35, 0x3e, 0x87, 0x1a, 0x15, 0xbe, 0xa0, 0x04, 0x14, 0xfe, 0x2c, 0x00, 0x15, 0xfe, 0x48, 
  0x0a, 0x45, 0x96, 0x94, 0x00, 0x44, 0xfe, 0x40, 0x00, 0x45, 0xbe, 0x44, 0x4d, 0x0c, 0xfe, 0xe4, 
  0x05, 0x17, 0xbe, 0x04, 0x1f, 0x17, 0xbe, 0x86, 0x00, 0x4c, 0xd6, 0xa0, 0x01, 0x4c, 0xea, 0x80, 
  0xff, 0x4c, 0xea, 0x4c, 0x0b, 0x3f, 0xbe, 0x80, 0x03, 0x16, 0xfe, 0x4c, 0x0b, 0x09, 0xbe, 0x80, 
  0x01, 0x16, 0xfe, 0x29, 0x01, 0x4a, 0xfe, 0x31, 0x01, 0x08, 0xf2, 0x84, 0x01, 0x16, 0xfe, 0x29, 
  0x01, 0x4a, 0xfe, 0x31, 0x02, 0x08, 0xf2, 0x84, 0x01, 0x4e, 0xfe, 0xa0, 0xb9, 0x96, 0xfd, 0x5c, 
  0x4d, 0x00, 0x7c, 0x5c, 0xe7, 0xde, 0xfd, 0x5c, 0x00, 0x4e, 0xfe, 0xa0, 0xf8, 0xe8, 0x3f, 0x61, 
  0x7f, 0x3a, 0xfe, 0x4c, 0x1d, 0x17, 0xbe, 0xb4, 0x18, 0x16, 0xfe, 0x2c, 0x0b, 0x4f, 0xbe, 0x68, 
  0xf7, 0xe8, 0x3f, 0x61, 0x7f, 0x38, 0xfe, 0x4c, 0x1c, 0x17, 0xbe, 0xb4, 0x18, 0x16, 0xfe, 0x2c, 
  0x08, 0x16, 0xfe, 0x28, 0x0b, 0x4f, 0xbe, 0x68, 0x26, 0x17, 0xbe, 0xa0, 0x08, 0x16, 0xfe, 0x2c, 
  0x0b, 0x4f, 0xbe, 0x68, 0x04, 0x17, 0xbe, 0xa0, 0x02, 0x16, 0xfe, 0x2c, 0x0b, 0x4f, 0xbe, 0x68, 
  0x09, 0x4f, 0x3e, 0x08, 0x00, 0x00, 0x7c, 0x5c, 0x09, 0x17, 0xbe, 0xa0, 0x04, 0x16, 0xfe, 0x80, 
  0x18, 0x15, 0xbe, 0xa0, 0x08, 0x14, 0xfe, 0x2c, 0x19, 0x15, 0xbe, 0x68, 0x08, 0x14, 0xfe, 0x2c, 
  0x1a, 0x15, 0xbe, 0x68, 0x08, 0x14, 0xfe, 0x2c, 0x1b, 0x15, 0xbe, 0x68, 0x0b, 0x15, 0x3e, 0x08, 
  0x04, 0x16, 0xfe, 0x80, 0x13, 0x15, 0xbe, 0xa0, 0x10, 0x14, 0xfe, 0x2c, 0x12, 0x15, 0xbe, 0x68, 
  0x0b, 0x15, 0x3e, 0x08, 0x04, 0x16, 0xfe, 0x80, 0x15, 0x15, 0xbe, 0xa0, 0x0b, 0x15, 0x3e, 0x08, 
  0x04, 0x16, 0xfe, 0x80, 0x16, 0x15, 0xbe, 0xa0, 0x0b, 0x15, 0x3e, 0x08, 0x04, 0x16, 0xfe, 0x80, 
  0x17, 0x15, 0xbe, 0xa0, 0x10, 0x14, 0xfe, 0x2c, 0x14, 0x15, 0xbe, 0x68, 0x0b, 0x15, 0x3e, 0x08, 
  0x00, 0x00, 0x7c, 0x5c, 0x01, 0x4a, 0xfe, 0xa4, 0x30, 0x08, 0xfe, 0xa0, 0x00, 0x4c, 0xfe, 0xa0, 
  0x00, 0x3a, 0xfe, 0xa0, 0x00, 0x38, 0xfe, 0xa0, 0x00, 0x34, 0xfe, 0xa0, 0x00, 0x0c, 0xfe, 0xa0, 
  0x00, 0x0e, 0xfe, 0xa0, 0x00, 0x00, 0x7c, 0x5c, 0x10, 0x16, 0xfe, 0x2c, 0x10, 0x18, 0xfe, 0xa0, 
  0x01, 0x14, 0xfe, 0x29, 0x0b, 0x15, 0xb2, 0x81, 0x01, 0x14, 0xfe, 0x31, 0xf3, 0x18, 0xfe, 0xe4, 
  0x00, 0x00, 0x7c, 0x5c, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x03, 0x00, 
  0x00, 0x40, 0x00, 0x00, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x13, 0x00, 0x00, 0x10, 
  0x12, 0x00, 0x00, 0x10, 0xff, 0xff, 0x00, 0x00, 0xa0, 0x0f, 0x00, 0x00, 0x14, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0e, 0x40, 0x0e, 0x71, 0x0f, 0x62, 0x0e, 0x53, 
  0x0e, 0x24, 0x0e, 0x15, 0x0f, 0xc6, 0x06, 0x0e, 0x66, 0x3f, 0x0e, 0x97, 0x0e, 0xa8, 0x0e, 0xd9, 
  0x66, 0xea, 0x66, 0xfb, 0x47, 0xbc, 0x47, 0x8d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0xbb, 0x03, 0x99, 0x00, 0xdd, 0x01, 0xee, 0x00, 0x1e, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 
  0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 
};
// =======[ Public Spin methods... ]===============================================
//
// -------[ Start and stop methods... ]--------------------------------------------
//
// Start and stop methods are used for starting individual cogs or stopping all
// of them at once.
int32_t scribbler_start(scribbler *self)
{
  int32_t	i, Register;
  // Main start routine for scribbler object. Stops ALL cogs, so
  // IT MUST BE CALLED FIRST, before starting other cogs.
  //
  // Example: scribbler.start 'Start scribbler object.
  scribbler_stop_all();
  // Detect the robot hardware model number.
  DIRA = ((DIRA & 0xfc3fffff) | 0x3c00000);
  // Set the mux address to the 3V3_I_ANG input.
  OUTA = ((OUTA & 0xfc3fffff) | 0x3000000);
  // Set both ADC pins to inputs.             
  DIRA &= ~(3<<_MUX_ADC_OUT);
  // Wait for the input to settle.
  waitcnt((CNT + (CLKFREQ / 10)));
  if (((INA >> _MUX_ADC_IN) & 0x1)) {
    ((uint8_t *)&dat[4723])[0] = MODEL_S2;
  } else {
    ((uint8_t *)&dat[4723])[0] = MODEL_S3;
  }
  ((int32_t *)&dat[1828])[0] = (int32_t)(&(*(uint16_t *)&dat[3060]));
  memset( (void *)((int32_t *)&dat[1828]), 0, sizeof(uint16_t)*40);
  ((int32_t *)&dat[1832])[0] = (int32_t)(&(*(uint16_t *)&dat[2904]));
  if ((((uint8_t *)&dat[4717])[0] = cognew((int32_t)(&(*(int32_t *)&dat[712])), ((*(uint8_t *)&dat[4723]) << 2)) + 1)) {
    OUTA = 0x10000000;
    DIRA = 0x10200000;
    scribbler__i2c_stop();
    if ((((uint8_t *)&dat[4721])[0] = scribbler__ee_rdbyte(self, EE_RESET_CNT))) {
      scribbler__ee_wrbyte(self, EE_RESET_CNT, 0);
    }
    if (((uint8_t *)&dat[4721])[0] > 8) {
      ((uint8_t *)&dat[4721])[0] = 0;
    }
    scribbler_read_wheel_calibration(self);
    scribbler_read_light_calibration(self);
    scribbler_read_line_threshold(self);
    scribbler_set_led(POWER, BLUE);
    if (scribbler_get_model_s3()) {
      // Configure the battery charger.
      // Read the charger source control register.
      Register = scribbler__BQ2495_rdbyte(self, 0);
      // Set Vin(min) to 5V.
      Register = Register | 0x70;
      // Clear HiZ disable bit.
      Register = Register & 0x7f;
      // Write the updated register back.
      scribbler__BQ2495_wrbyte(self, 0, Register);
      // OTG Enable, Charge Enable, Watch Dog Reset, Vsys Min 3.0V.
      scribbler__BQ2495_wrbyte(self, 1, 113);
      // Ichrg = 1984 mA.
      scribbler__BQ2495_wrbyte(self, 2, 92);
      // I PreChrg 512 mA, I term 128 mA.
      scribbler__BQ2495_wrbyte(self, 3, 48);
      // Vchrg 4.208, Bat Low 3.0V.
      scribbler__BQ2495_wrbyte(self, 4, 178);
      // Charge Term En, WatchDog Dis, Chg Tmr 20 hours. 
      scribbler__BQ2495_wrbyte(self, 5, 142);
      // Boost = 5.062V, Bhot 65C, Treg 100C. 
      scribbler__BQ2495_wrbyte(self, 6, 138);
      // TMR2x En, BATFET On, Disable Interupts.
      scribbler__BQ2495_wrbyte(self, 7, 72);
    }
    scribbler_delay_tenths(5);
    return -1;
  } else {
    return 0;
  }
}

int32_t scribbler_start_motors(scribbler *self)
{
  int32_t result = 0;
  // Start motor control cog.
  //
  // Example: scribbler.start_motors 'Start the motor controller.
  if (!(((uint8_t *)&dat[4720])[0])) {
    ((uint16_t *)&dat[3010])[0] = -1;
    ((int32_t *)&dat[2892])[0] = (int32_t)(&(*(uint16_t *)&dat[3060])) + (CNT_IDLER << 1);
    result = -((((uint8_t *)&dat[4720])[0] = cognew((int32_t)(&(*(int32_t *)&dat[1848])), (int32_t)(&(*(uint16_t *)&dat[3010]))) + 1) > 0);
    while ((*(uint16_t *)&dat[3010])) {
      Yield__();
    }
    ((uint8_t *)&dat[4716])[0] = 0;
    scribbler_here_is(0, 0);
    scribbler_heading_is((*(uint16_t *)&dat[2998]));
    scribbler_set_speed(7);
  }
  return result;
}

int32_t scribbler_start_tones(scribbler *self)
{
  int32_t result = 0;
  // Start tone sequencer.
  //
  // Example: scribbler.start_tones 'Start the tone sequencer/generator.
  if (!(((uint8_t *)&dat[4718])[0])) {
    memset( (void *)&(*(uint16_t *)&dat[3108]), 0, sizeof(uint16_t)*(_TONE_Q_SIZE + 4));
    ((int32_t *)&dat[656])[0] = (CLKFREQ / 65536) * 2;
    ((int32_t *)&dat[660])[0] = (int32_t)(&(*(uint16_t *)&dat[3108]));
    result = -((((uint8_t *)&dat[4718])[0] = cognew((int32_t)(&(*(int32_t *)&dat[112])), 0) + 1) > 0);
    scribbler_command_tone(PLAY);
  }
  return result;
}

int32_t scribbler_start_mic_env()
{
  // Start microphone Envelope detector.
  //
  // Example: scribbler.start_mic_env 'Start the microphone Envelope detector.
  if (!(((uint8_t *)&dat[4719])[0])) {
    ((int32_t *)&dat[100])[0] = CLKFREQ / 8000;
    ((int32_t *)&dat[96])[0] = 8000 / 20;
    return -((((uint8_t *)&dat[4719])[0] = cognew((int32_t)(&(*(int32_t *)&dat[0])), (int32_t)(&(*(int32_t *)&dat[2972]))) + 1) > 0);
  }
  return 0;
}

int32_t scribbler_stop_all()
{
  // Stop ALL cogs.
  //
  // Example: scribbler.stop_all 'Stop all scribbler cogs.
  if ((*(uint8_t *)&dat[4717])) {
    cogstop((PostEffect__((*(uint8_t *)&dat[4717]), 0) - 1));
  }
  if ((*(uint8_t *)&dat[4718])) {
    cogstop((PostEffect__((*(uint8_t *)&dat[4718]), 0) - 1));
  }
  if ((*(uint8_t *)&dat[4719])) {
    cogstop((PostEffect__((*(uint8_t *)&dat[4719]), 0) - 1));
  }
  if ((*(uint8_t *)&dat[4720])) {
    cogstop((PostEffect__((*(uint8_t *)&dat[4720]), 0) - 1));
  }
  return 0;
}

/* 
---------[ Microphone methods... ]---------------------------------------------

   Microphone methods provide data from the scribbler's built-in microphone.
 */
int32_t scribbler_get_mic_env()
{
  // Get the average loudness (Envelope) value of the microphone input.
  //
  // Example: loudness := scribbler.get_mic_env 'Set loudness equal to current mic level.
  return (*(int32_t *)&dat[2972]);
}

/* 
---------[ Drawing methods... ]---------------------------------------------------

   Drawing methods can be used for drawing with the scribbler or for any application
   that requires keeping track of the robot's position and heading.
 */
int32_t scribbler_begin_path()
{
  // Begin a path of connected movements.
  //
  // Example: scribbler.begin_path
  if (!(((uint8_t *)&dat[4716])[0])) {
    ((uint8_t *)&dat[4716])[0] = 1;
  }
  return 0;
}

int32_t scribbler_end_path(scribbler *self)
{
  // Output the last movement in the path, if there is one, and end the path.
  // NOTE: Omitting this statement may cause the last path segment not to be drawn.
  //
  // Example: scribbler.end_path
  if (((uint8_t *)&dat[4716])[0] == 2) {
    scribbler_run_motors(0, (*(int32_t *)&dat[3048]), (*(int32_t *)&dat[3044]), (*(int32_t *)&dat[3052]), (*(int32_t *)&dat[3056]), 0);
  }
  ((uint8_t *)&dat[4716])[0] = 0;
  return 0;
}

int32_t scribbler_set_speed(int32_t spd)
{
  // Set the speed (0 - 15) for the drawing methods, along with the "go_", "turn_",
  // and "arc_" motion methods.
  //
  // Example: set_speed(7) 'Set the speed to half of maximum velocity.
  ((uint8_t *)&dat[4722])[0] = spd;
  return 0;
}

int32_t scribbler_move_to(scribbler *self, int32_t x, int32_t y)
{
  // Move directly to the point (x, y).
  // Units are approximately 0.5mm.
  //
  // Example: scribbler.move_to(1000, 50) 'Move to a point 500 mm to the right and 25mm above the origin.
  scribbler_move_by(self, (x - (*(int32_t *)&dat[2976])), (y - (*(int32_t *)&dat[2980])));
  return 0;
}

int32_t scribbler_arc_to(scribbler *self, int32_t x, int32_t y, int32_t radius)
{
  // Move to the point (x, y) via an arc of the specified radius (+radius is CCW; -radius is CW).
  // The Cartesian distance from the current location to the target position must be no more than
  // 2 * radius. If it's greater than that, the robot will move in a straight line to the target
  // position first to make up the difference, then perform the arc.
  // Units are approximately 0.5mm.
  //
  // Example: scribbler.arc_to(1000, 50, -100) 'Move to the point 500 mm to the right and 25mm above the origin
  //                                    '  in a clockwise arc of radius 25mm.
  scribbler_arc_by(self, (x - (*(int32_t *)&dat[2976])), (y - (*(int32_t *)&dat[2980])), radius);
  return 0;
}

int32_t scribbler_move_by(scribbler *self, int32_t dx, int32_t dy)
{
  int32_t	angle;
  // Move from the current location by the displacement (dx, dy).
  // Units are approximately 0.5mm.
  //
  // Example: scribbler.move_by(100, 50) 'Move to a point 50 mm to the right and 25mm above the current location.
  scribbler_turn_to(self, (angle = scribbler__atan2(dy, dx)));
  scribbler_go_forward(self, (Sqrt__(((dx * dx) + (dy * dy)))));
  scribbler_here_is(((*(int32_t *)&dat[2976]) + dx), ((*(int32_t *)&dat[2980]) + dy));
  return 0;
}

int32_t scribbler_arc_by(scribbler *self, int32_t dx, int32_t dy, int32_t radius)
{
  int32_t	dist2, dist, diam, half_angle, tilt;
  // Move from the current location byt the displacement (dx, dy) via an arc of the specified radius
  // (+radius is CCW; -radius is CW). The Cartesian length of the displacement must be no more than
  // 2 * radius. If it's greater than that, the robot will move in a straight line to the target
  // position first to make up the difference, then perform the arc. Units are approximately 0.5mm.
  //
  // Example: scribbler.arc_by(50, 50, -100) 'Move to the point 25 mm to the right of and 25mm above the 
  //                                  '  current location in a clockwise arc of radius 50mm.
  dist2 = (dx * dx) + (dy * dy);
  dist = Sqrt__(dist2);
  tilt = scribbler__atan2(dy, dx);
  diam = (abs(radius)) << 1;
  if (dist > diam) {
    scribbler_turn_to(self, tilt);
    scribbler_go_forward(self, (dist - diam));
    dist = diam;
    dist2 = dist * dist;
  }
  half_angle = scribbler__atan2((Shr__(dist, 1)), (Sqrt__(((radius * radius) - (Shr__(dist2, 2))))));
  if (radius < 0) {
    half_angle = -half_angle;
  }
  scribbler_turn_to(self, (tilt - half_angle));
  scribbler_arc(self, (half_angle << 1), radius);
  scribbler_here_is(((*(int32_t *)&dat[2976]) + dx), ((*(int32_t *)&dat[2980]) + dy));
  scribbler_heading_is((tilt + half_angle));
  return 0;
}

int32_t scribbler_align_with(scribbler *self, int32_t heading)
{
  int32_t	dw;
  int32_t result = 0;
  // Turn so that the robot is pointed parallel to the desired heading (scribbler angle units),
  // either in the selected direction (returns 1) or opposite the selected direction
  // (returns -1), whichever requires the shortest turn to achieve.
  //
  // Example: dir := scribbler.align_with(150) 'Point the robot to angle 150 (scribbler angle units)
  //                                    '  or opposite that angle. Set dir to +/-1, accordingly.
  dw = (heading - (*(int32_t *)&dat[2984])) % (*(uint16_t *)&dat[2992]);
  dw = dw + ((*(uint16_t *)&dat[2992]) & -(dw < 0));
  if (dw > ((uint16_t *)&dat[2996])[0]) {
    dw = dw - (*(uint16_t *)&dat[2992]);
  }
  if ((abs(dw)) <= ((uint16_t *)&dat[2998])[0]) {
    result = 1;
  } else {
    dw = (dw - (*(uint16_t *)&dat[2996])) + ((*(uint16_t *)&dat[2992]) & -(dw < 0));
    result = -1;
  }
  scribbler_turn(self, dw);
  scribbler_heading_is(((*(int32_t *)&dat[2984]) + dw));
  return result;
}

int32_t scribbler_turn_to_deg(scribbler *self, int32_t heading)
{
  // Turn the robot to the desired heading (degrees).
  //
  // Example: scribbler.turn_to(135) 'Point the robot to an angle of 135 degrees.
  scribbler_turn_to(self, ((heading * (*(uint16_t *)&dat[2992])) / 360));
  return 0;
}

int32_t scribbler_turn_to(scribbler *self, int32_t heading)
{
  // Turn the robot to the desired heading (scribbler angle units).
  //
  // Example: scribbler.turn_to(500) 'Point the robot to an angle of 500 scribbler angle units.
  scribbler_turn_by(self, (heading - (*(int32_t *)&dat[2984])));
  return 0;
}

int32_t scribbler_turn_by_deg(scribbler *self, int32_t dw)
{
  // Turn the robot by the desired amount (degrees). +dw is CCW; -dw is CW.
  // If the net turn angle is greater than 180 degrees, the shorter rotation
  // in the opposite direction is used instead.
  //
  // Example: scribbler.turn_by_deg(90) 'Rotate the robot by an angle of 90 degrees CCW.
  scribbler_turn_by(self, ((dw * (*(uint16_t *)&dat[2992])) / 360));
  return 0;
}

int32_t scribbler_turn_by(scribbler *self, int32_t dw)
{
  // Turn the robot by the desired amount (scribbler angle units). +dw is CCW; -dw is CW.
  // If the net turn angle is greater than Full_circle / 2, the shorter rotation
  // in the opposite direction is used instead.
  //
  // Example: scribbler.turn_by(500) 'Rotate the robot by an angle of 500 scribbler angle units CCW.
  dw = dw % (*(uint16_t *)&dat[2992]);
  dw = dw + ((*(uint16_t *)&dat[2992]) & -(dw < 0));
  if (dw > ((uint16_t *)&dat[2996])[0]) {
    dw = dw - (*(uint16_t *)&dat[2992]);
  }
  scribbler_turn(self, dw);
  scribbler_heading_is(((*(int32_t *)&dat[2984]) + dw));
  return 1;
}

int32_t scribbler_here_is(int32_t x, int32_t y)
{
  // Reset the current position to (x,y). Units are approximately 0.5mm.
  //
  // Example: scribbler.here_is(0, 0) 'Reset the origin to the current location.
  ((int32_t *)&dat[2976])[0] = x;
  ((int32_t *)&dat[2980])[0] = y;
  return 0;
}

int32_t scribbler_heading_is_deg(scribbler *self, int32_t w)
{
  // Reset the current heading to w degrees.
  //
  // Example: scribbler.heading_is_deg(90) 'Reset the current heading to 90 degrees.
  scribbler_heading_is(((w * (*(uint16_t *)&dat[2992])) / 360));
  return 0;
}

int32_t scribbler_heading_is(int32_t w)
{
  // Reset the current heading to w.
  //
  // Example: scribbler.heading_is(567) 'Reset the current heading to 567.
  ((int32_t *)&dat[2984])[0] = w % (*(uint16_t *)&dat[2992]);
  ((int32_t *)&dat[2984])[0] = (*(int32_t *)&dat[2984]) + ((*(uint16_t *)&dat[2992]) & -((*(int32_t *)&dat[2984]) < 0));
  return 0;
}

/* 
---------[ Motion methods... ]-------------------------------------------------

   Motion methods control the movement of the scribbler robot. MOTION METHODS DO NOT
   KEEP TRACK OF THE SCRIBBLERS'S POSITION AND HEADING, unless called from one of the
   drawing methods. As such, they should NOT be mixed with calls to drawing
   methods.
 */
int32_t scribbler_read_wheel_calibration(scribbler *self)
{
  int32_t _local__0001[2];
  // Read calibration values from EEPROM, and use them if they're reasonable.
  // Returns a packed long containing the calibration values. If no valid values
  // exist in EEPROM, sets (and returns) the default values.
  //
  // Example: scribbler.read__wheel_calibration 'Get previously-written wheel calibration values.
  if (scribbler__ee_rdblock(self, (int32_t)(&_local__0001[0]), EE_WHEEL_CALIB, 4)) {
    _local__0001[1] = Shr__(_local__0001[0], 16);
    _local__0001[0] = _local__0001[0] & 0xffff;
    if ((((_local__0001[0] > 900) && (_local__0001[0] < 1000)) && (_local__0001[1] > 100)) && (_local__0001[1] < 200)) {
      return scribbler_set_wheel_calibration(self, _local__0001[0], _local__0001[1]);
    }
  }
  return scribbler_default_wheel_calibration(self);
}

int32_t scribbler_write_wheel_calibration(scribbler *self)
{
  // Write current wheel calibration values to EEPROM.
  // Returns true on success, false on failure.
  //
  // Example: scribbler.write_wheel_calibration 'Write Full_circle and Wheel_space to EEPROM.
  return scribbler__ee_wrblock(self, (int32_t)(&(*(uint16_t *)&dat[2992])), EE_WHEEL_CALIB, 4);
}

int32_t scribbler_default_wheel_calibration(scribbler *self)
{
  // Restore calibration to default values. DOES NOT SAVE IN EEPROM.
  // This method is optional unless read_calibration or set_calibration
  // have been called.
  //
  // Example: scribbler.default_calibration 'Restore calibration defaults.
  return scribbler_set_wheel_calibration(self, DEFAULT_FULL_CIRCLE, DEFAULT_WHEEL_SPACE);
}

int32_t scribbler_set_wheel_calibration(scribbler *self, int32_t circle, int32_t space)
{
  // Set calibration values to method's arguments, if they're reasonable.
  // DOES NOT SAVE IN EEPROM.
  //
  // Example: scribbler.set_wheel_calibration(960, 160) 'Set Full_circle to 960 and
  //                                             'Wheel_space to 160.
  ((uint16_t *)&dat[2992])[0] = circle;
  ((uint16_t *)&dat[2994])[0] = space;
  scribbler__compute_calibration();
  return scribbler_get_wheel_calibration();
}

int32_t scribbler_get_wheel_calibration()
{
  // Gets current calibration values: Full_circle in top 16 bits;
  // Wheel_space in bottom 16 bits.
  return (((*(uint16_t *)&dat[2992]) << 16) | (*(uint16_t *)&dat[2994]));
}

int32_t scribbler_go_left(scribbler *self, int32_t dist)
{
  // Turn left and go forward from there by the indicated distance. Units are
  // approximately 0.5mm.
  //
  // Example: scribbler.go_left(500) 'Turn left and move forward 250mm.
  scribbler_turn_deg(self, 90);
  scribbler_go_forward(self, dist);
  return 0;
}

int32_t scribbler_go_right(scribbler *self, int32_t dist)
{
  // Turn right and go forward from there by the indicated distance. Units are
  // approximately 0.5mm.
  //
  // Example: scribbler.go_right(500) 'Turn right and move forward 250mm.
  scribbler_turn_deg(self, (-90));
  scribbler_go_forward(self, dist);
  return 0;
}

int32_t scribbler_go_forward(scribbler *self, int32_t dist)
{
  // Go forward by the indicated distance. Units are approximately 0.5mm.
  //
  // Example: scribbler.go_forward(500) 'Move forward 250mm.
  if ((abs(dist)) == FOREVER) {
    scribbler_move(self, 100, 100, 0, (*(uint8_t *)&dat[4722]), 1);
  } else {
    scribbler_move(self, dist, dist, 0, (*(uint8_t *)&dat[4722]), 0);
  }
  return 0;
}

int32_t scribbler_go_back(scribbler *self, int32_t dist)
{
  // Go backward by the indicated distance. Units are approximately 0.5mm.
  //
  // Example: scribbler.go_back(500) 'Move back 250mm.
  if ((abs(dist)) == FOREVER) {
    scribbler_move(self, (-100), (-100), 0, (*(uint8_t *)&dat[4722]), 1);
  } else {
    scribbler_move(self, (-dist), (-dist), 0, (*(uint8_t *)&dat[4722]), 0);
  }
  return 0;
}

int32_t scribbler_turn_deg(scribbler *self, int32_t ccw_degrees)
{
  // Turn in place counter-clockwise by the indicated number of degrees.
  // Negative values will turn clockwise.
  //
  // Example: scribbler.turn_deg(-90) 'Turn right.
  scribbler_arc_deg(self, ccw_degrees, 0);
  return 0;
}

int32_t scribbler_arc_deg(scribbler *self, int32_t ccw_degrees, int32_t radius)
{
  int32_t	r, l;
  // Move in a counter-clockwise arc of the indicated radius by the specified
  // number of degrees. Radius units are approximately 0.5mm. Negative angles
  // result in a clockwise arc.
  //
  // Example: scribbler.arc_deg(90, 500) 'Make a sweeping left turn with a radius of 250mm.
  scribbler_arc(self, (((*(uint16_t *)&dat[2992]) * ccw_degrees) / 360), radius);
  return 0;
}

int32_t scribbler_turn(scribbler *self, int32_t ccw_units)
{
  // Turn in place counter-clockwise by the indicated number of degrees.
  // Negative values will turn clockwise.
  //
  // Example: scribbler.turn(-50) 'Turn a bit to the right by 50 scribbler angle units.
  scribbler_arc(self, ccw_units, 0);
  return 0;
}

int32_t scribbler_arc(scribbler *self, int32_t ccw_units, int32_t radius)
{
  int32_t	r, l;
  // Move in a counter-clockwise arc of the indicated radius by the specified
  // number of scribbler angle units. Radius units are approximately 0.5mm. Negative angles
  // result in a clockwise arc.
  //
  // Example: scribbler.arc(100, 50) 'Arc a bit to the left by 100 scribbler angle units with
  //                          '  a 25mm radius.
  r = (ccw_units * (radius + (*(uint16_t *)&dat[2994]))) / (*(uint16_t *)&dat[2994]);
  l = (ccw_units * (radius - (*(uint16_t *)&dat[2994]))) / (*(uint16_t *)&dat[2994]);
  scribbler_move(self, l, r, 0, (*(uint8_t *)&dat[4722]), 0);
  return 0;
}

int32_t scribbler_turn_deg_now(scribbler *self, int32_t ccw_degrees)
{
  // Turn in place counter-clockwise by the indicated number of degrees.
  // Negative values will turn clockwise.
  // Preempts current motion in progress.
  //
  // Example: scribbler.turn_deg_now(-90) 'Immediate turn right.
  scribbler_arc_deg_now(self, ccw_degrees, 0);
  return 0;
}

int32_t scribbler_arc_deg_now(scribbler *self, int32_t ccw_degrees, int32_t radius)
{
  int32_t	r, l;
  // Move in a counter-clockwise arc of the indicated radius by the specified
  // number of degrees. Radius units are approximately 0.5mm. Negative angles
  // result in a clockwise arc.
  // Preempts current motion in progress.
  //
  // Example: scribbler.arc_deg_now(90, 500) 'Make an immediate sweeping left turn
  //                                  'with a radius of 250mm.
  scribbler_arc_now(self, (((*(uint16_t *)&dat[2992]) * ccw_degrees) / 360), radius);
  return 0;
}

int32_t scribbler_turn_now(scribbler *self, int32_t ccw_units)
{
  // Turn in place counter-clockwise by the indicated number of degrees.
  // Negative values will turn clockwise.
  // Preempts current motion in progress.
  //
  // Example: scribbler.turn_now(-50) 'Immediately turn a bit to the right by 50 scribbler angle units.
  scribbler_arc_now(self, ccw_units, 0);
  return 0;
}

int32_t scribbler_arc_now(scribbler *self, int32_t ccw_units, int32_t radius)
{
  int32_t	r, l;
  // Move in a counter-clockwise arc of the indicated radius by the specified
  // number of scribbler angle units. Radius units are approximately 0.5mm. Negative angles
  // result in a clockwise arc.
  // Preempts current motion in progress.
  //
  // Example: scribbler.arc_now(100, 50) 'Immediately arc a bit to the left by 100 scribbler angle
  //                              'units with a 25mm radius.
  r = (ccw_units * (radius + (*(uint16_t *)&dat[2994]))) / (*(uint16_t *)&dat[2994]);
  l = (ccw_units * (radius - (*(uint16_t *)&dat[2994]))) / (*(uint16_t *)&dat[2994]);
  scribbler_move_now(self, l, r, 0, (*(uint8_t *)&dat[4722]), 0);
  return 0;
}

int32_t scribbler_move(scribbler *self, int32_t left_distance, int32_t right_distance, int32_t move_time, int32_t max_speed, int32_t no_stop)
{
  int32_t	max_d, max_pd, max_rvel, max_lvel, end_spd;
  int32_t result = 0;
  // Base-level non-reactive user move routine. Does not interrupt motion in progress.
  // If called during path construction, velocities will blend. If no path, velocity ramps to zero at end.
  // This method may not return right away if it has to wait for current motion to complete.
  //
  // left_distance: Amount to move left wheel (-32767 - 32767) in 0.5mm (approx.) increments.
  // right_distance: Amount to move right wheel (-32767 - 32767) in 0.5mm (approx.) increments.
  // move_time: If non-zero, time (ms) after which to stop, regardless of distance traveled.
  // max_speed (0 - 15): Maximum speed (after ramping).
  // no_stop: If non-zero, keep running, regardless of distance traveled unless/until timeout or a preemptive change.
  //
  // Example: scribbler.move(10000, 5000, 10000, 7, 0) 'Move in a clockwise arc for 10000/2 mm on outside, or until 10 seconds elapse,
  //                                            '  whichever occurs first, at half speed.
  left_distance = Min__((Max__((-32767), left_distance)), 32767);
  right_distance = Min__((Max__((-32767), right_distance)), 32767);
  max_speed = Min__((Max__(0, max_speed)), 15);
  ((uint8_t *)&dat[4722])[0] = max_speed;
  if (((uint8_t *)&dat[4716])[0] == 2) {
    if (((left_distance ^ (*(int32_t *)&dat[3048])) & 0x8000) || ((right_distance ^ (*(int32_t *)&dat[3044])) & 0x8000)) {
      end_spd = 0;
    } else {
      max_d = Max__((abs(left_distance)), (abs(right_distance)));
      max_pd = Max__((abs((*(int32_t *)&dat[3048]))), (abs((*(int32_t *)&dat[3044]))));
      /* 
              
       */
      max_rvel = ((Min__(((((abs(right_distance)) * max_speed) + (Shr__(max_d, 1))) / max_d), ((((abs((*(int32_t *)&dat[3044]))) * (*(int32_t *)&dat[3056])) + (Shr__(max_pd, 1))) / max_pd))) * max_d) / (Max__((abs(right_distance)), 1));
      /* 
              
       */
      max_lvel = ((Min__(((((abs(left_distance)) * max_speed) + (Shr__(max_d, 1))) / max_d), ((((abs((*(int32_t *)&dat[3048]))) * (*(int32_t *)&dat[3056])) + (Shr__(max_pd, 1))) / max_pd))) * max_d) / (Max__((abs(left_distance)), 1));
      end_spd = Min__(max_rvel, max_lvel);
    }
    scribbler_run_motors(0, (*(int32_t *)&dat[3048]), (*(int32_t *)&dat[3044]), (*(int32_t *)&dat[3052]), (*(int32_t *)&dat[3056]), end_spd);
    result = end_spd;
  }
  if (((uint8_t *)&dat[4716])[0] >= 1) {
    if ((no_stop) && (move_time == 0)) {
      scribbler_run_motors(MOT_CONT, left_distance, right_distance, move_time, max_speed, 0);
      ((uint8_t *)&dat[4716])[0] = 0;
    } else {
      ((int32_t *)&dat[3048])[0] = left_distance;
      ((int32_t *)&dat[3044])[0] = right_distance;
      ((int32_t *)&dat[3052])[0] = move_time;
      ((int32_t *)&dat[3056])[0] = max_speed;
      ((uint8_t *)&dat[4716])[0] = 2;
    }
  } else {
    scribbler_run_motors((MOT_CONT & -(no_stop != 0)), left_distance, right_distance, move_time, max_speed, 0);
  }
  return result;
}

int32_t scribbler_wheels_now(scribbler *self, int32_t left_velocity, int32_t right_velocity, int32_t move_time)
{
  // Set the wheel speeds preemptively to left_velocity and right_velocity (-255 to 255).
  // If move_time > 0, time out after move_time ms.
  // Interrupts any movement in progress and deletes all path information.
  // This method always returns immediately.
  //
  // Example: scribbler.wheels_now(-255, 255, 5000) 'Turn left, in place, at maximum speed, for five seconds. 
  scribbler_move_now(self, left_velocity, right_velocity, move_time, (Shr__((Min__((Max__((abs(left_velocity)), (abs(right_velocity)))), 255)), 4)), 1);
  return 0;
}

int32_t scribbler_move_now(scribbler *self, int32_t left_distance, int32_t right_distance, int32_t move_time, int32_t max_speed, int32_t no_stop)
{
  // Base-level preemptive user routine for reactive movements (e.g. for line following).
  // Interrupts any movement in progress and deletes all path information.
  // This method always returns immediately. 
  //
  // left_distance: Amount to move left wheel (-32767 - 32767) in 0.5mm (approx.) increments.
  // right_distance: Amount to move right wheel (-32767 - 32767) in 0.5mm (approx.) increments.
  // move_time: If non-zero, time (ms) after which to stop, regardless of distance traveled.
  // max_speed (0 - 15): Maximum speed (after ramping).
  // no_stop: If non-zero, keep running, regardless of distance traveled unless/until timeout or another preemptive change.
  //
  // Example: scribbler.move_now(1000, -1000, 0, 15, 1) 'Rotate in place clockwise at full speed until preempted.  
  ((uint8_t *)&dat[4716])[0] = 0;
  scribbler_run_motors((MOT_IMM | (MOT_CONT & -(no_stop != 0))), left_distance, right_distance, move_time, max_speed, 0);
  return 0;
}

int32_t scribbler_stop_now(scribbler *self)
{
  // Stops movement immediately and deletes all path information.
  //
  // Example: scribbler.stop_now.
  ((uint8_t *)&dat[4716])[0] = 0;
  scribbler_run_motors(MOT_IMM, 0, 0, 0, 0, 0);
  return 0;
}

int32_t scribbler_wait_stop(scribbler *self)
{
  // Wait for all current and pending motions to complete.
  //
  // Example: scribbler.wait_stop
  while (scribbler_moving()) {
    Yield__();
  }
  return 0;
}

int32_t scribbler_stalled(scribbler *self)
{
  int32_t	stat, mvel, ivel, itime, vstall, istall;
  // Checks whether the scribbler is stalled by testing both the motor current
  // and the activitity of the idler wheel encoder.
  // Returns true if stalled; false if not.
  //
  // Example: repeat until scribbler.stalled 'Execute the repeat block as long as the bot is not stalled.
  if ((stat = (*(int32_t *)&dat[3020])) & 0x3) {
    mvel = abs(((stat >> 24) + ((stat << 8) >> 24)));
    itime = (Shr__(stat, 8)) & 0xff;
    if (!((ivel = (stat & 0xfc) << 3))) {
      ivel = 512 / itime;
    }
    if ((vstall = -(((mvel * 14) / ivel) > (20 + (*(int32_t *)&dat[2988]))))) {
      ((int32_t *)&dat[2988])[0] = -2;
    } else {
      ((int32_t *)&dat[2988])[0] = 2;
    }
    istall = -(scribbler_get_adc_results(ADC_IMOT) > (Shr__((75 * scribbler_get_adc_results(ADC_VBAT)), 7)));
    return -(vstall || istall);
  }
  return 0;
}

int32_t scribbler_moving()
{
  // Return TRUE if motion in progress or pending, FALSE if stopped with no pending motions.
  //
  // Example: repeat while scribbler.moving 'Continuously execute the following repeat block until motions are finished.
  return -(((*(int32_t *)&dat[3020]) & 0x3) != 0);
}

int32_t scribbler_motion()
{
  // Return current motion status:
  //
  // 31            24 23           16 15            8 7         2 1 0
  // +---------------------------------------------------------------+
  // |+/- Left wheel |+/- Right wheel|  Idler timer  | Idler spd |Mov| , where
  // +---------------------------------------------------------------+
  //
  // Left wheel and right wheel are signed, twos complement eight bit velocity values,
  // Idler timer is the time in 1/10 second since the last idler edge,
  // Idler spd is an unsigned six-bit velocity value, and
  // Mov is non-zero iff one or more motors are turning.
  // Left and right wheel velocities are instanteous encoder counts over a 1/10-second interval.
  // Idler wheel wheel velocity is updated every 1/10 second and represents the idler encoder count during the last 1.6 seconds.
  //
  // Example: left_vel := scribbler.motion ~> 24 'Get the current left wheel velocity as a signed 32-bit value.
  return (*(int32_t *)&dat[3020]);
}

int32_t scribbler_motion_addr()
{
  // Return the address of the status and debug array.
  //
  // Example: longmove(@my_stats, scribbler.motion_addr, 6) 'Copy all status data to the local array my_stats.
  return (int32_t)(&(*(int32_t *)&dat[3020]));
}

int32_t scribbler_move_ready()
{
  // Return TRUE if a new motion command can be accepted without waiting, FALSE if a command is still pending.
  //
  // Example: repeat until scribbler.move_ready 'Continuously execute the following repeat block until a new move can be accepted.
  return -((*(uint16_t *)&dat[3010]) == 0);
}

int32_t scribbler_run_motors(int32_t command, int32_t left_distance, int32_t right_distance, int32_t timeout, int32_t max_speed, int32_t end_speed)
{
  /*  Base level motor activation routine. Normally, this method is not called by the user but is called by the
       several convenience methods available to the user.
    
   */
  //
  // `command: the OR of any or all of the following:
  //
  //   MOT_IMM:   Commanded motion starts immediately, without wating for prior motion to finish.
  //   MOT_CONT:  Commanded motion will continue to run at wheel ratio given by left and right distances,
  //                even after distances are covered.
  //
  // `left_distance, `right_distance (-32767 to 32767):
  //
  //
  //   The distances to be covered by the left and right wheels, respectively. Units are approximately 0.5mm.
  //
  // `timeout (0 - 65535): If non-zero, time limit (ms) after which motion stops, regardless of distance covered.
  //
  // `max_speed (0 - 15): Peak velocity to be reached during motion profile.
  //
  // `end_speed (0 - 15):
  //
  //   Velocity to be attained at end of motion profile. If non-zero, this is the velocity needed to
  //   segue smoothly into the next motion profile. end_speed should never be greater than max_speed.
  //
  // `Example: scribbler.run_motors(scribbler#MOT_CONT | scribbler#MOT_TIMED, 100, -100, 5000, 8, 0) 'Turn in place clockwise for 5 seconds at half speed. 
  if (command & MOT_IMM) {
    ((int32_t *)(int32_t)(&(*(uint16_t *)&dat[3014])))[0] = 0;
    ((int32_t *)(int32_t)(&(*(uint16_t *)&dat[3010])))[0] = 0;
  } else {
    while (((int32_t *)(int32_t)(&(*(uint16_t *)&dat[3010])))[0]) {
      Yield__();
    }
  }
  ((uint16_t *)&dat[3014])[0] = Min__((Max__((-32767), right_distance)), 32767);
  ((uint16_t *)&dat[3016])[0] = Min__((Max__((-32767), left_distance)), 32767);
  ((int32_t *)(int32_t)(&(*(uint16_t *)&dat[3010])))[0] = (((timeout << 16) | ((Min__((Max__(0, max_speed)), 15)) << 8)) | ((Min__((Max__(0, end_speed)), 15)) << 4)) | (command & (MOT_IMM | MOT_CONT));
  if ((left_distance) || (right_distance)) {
    timeout = CNT;
    while (!((scribbler_moving()) || ((CNT - timeout) > 800000))) {
      Yield__();
    }
  }
  return 0;
}

//
//
// -------[ Sensor methods... ]-------------------------------------------------
//
// Sensor methods return information about the scribbler's various onboard sensors.
//
/*  `NOTE: The following obstacle threshold methods affect only the obstacle sensor threshold used when
   `obstacle is called with a threshold value of zero.
 */
int32_t scribbler_read_obstacle_threshold(scribbler *self)
{
  int32_t _local__0002[1];
  /*  Read the obstacle threshold value from EEPROM, and substitute it for the
       default if the checksum is correct and the value is within reasonable bounds.
       Returns the threshold value read on success.
       If no valid calibration values exist in EEPROM, sets to (and returns) the
       default value, DEFAULT_OBSTACLE_THLD.
    ''
    '' `Example: scribbler.read_obstacle_threshold
    ''
    ''     Get previously-written obstacle threshold value.
    
   */
  if (scribbler__ee_rdblock(self, (int32_t)(&_local__0002[0]), EE_OBSTACLE_THLD, 1)) {
    _local__0002[0] = _local__0002[0] & 0xff;
    if ((_local__0002[0] > 0) && (_local__0002[0] <= 100)) {
      return scribbler_set_obstacle_threshold(_local__0002[0]);
    }
  }
  return scribbler_default_obstacle_threshold(self);
}

int32_t scribbler_write_obstacle_threshold(scribbler *self)
{
  /*  Write the current obstacle threhsold value to EEPROM.
       Returns true on a successful write; false otherwise.
    ''
    '' `Example: scribbler.write_obstacle_threshold
    ''
    ''     Write current obstacle threshold value to EEPROM.
    
   */
  return scribbler__ee_wrblock(self, (int32_t)(&(*(uint8_t *)&dat[3006])), EE_OBSTACLE_THLD, 1);
}

int32_t scribbler_default_obstacle_threshold(scribbler *self)
{
  /*  Restore the obstacle threshold to its default value. DOES NOT SAVE IN EEPROM.
       This method is optional unless `read_obstacle_threshold or `set_obstacle_threshold
       has been called successfully. Returns the default value, DEFAULT_OBSTACLE_THRESHOLD.
    ''
    '' `Example: scribbler.default_obstacle_threshold
    ''
    ''     Restore calibration default.
    
   */
  return scribbler_set_obstacle_threshold(DEFAULT_OBSTACLE_THLD);
}

int32_t scribbler_set_obstacle_threshold(int32_t thld)
{
  /*  Set the obstacle sensor threshold to thld. DOES NOT SAVE IN EEPROM. Returns the value set.
    ''  
    '' `Example: scribbler.set_obstacle_threhsold(10)
    ''
    ''     Set obstacle sensor threshold to 10.
    ''
       This becomes the value used when the `obstacle method is called with an argument of zero.
    
   */
  return (((uint8_t *)&dat[3006])[0] = thld);
}

int32_t scribbler_get_obstacle_threshold()
{
  // Returns the current obstacle sensor threshold.
  //
  // `Example: Thld := scribbler.get_obstacle_threshold
  //
  //     Set `Thld to the current obstacle threshold.
  return (*(uint8_t *)&dat[3006]);
}

int32_t scribbler_obstacle(int32_t side, int32_t threshold)
{
  int32_t result = 0;
  // Return the value of the obstacle detection: `true = obstacle; `false = no obstacle.
  // 
  // `side (LEFT or RIGHT): Select the side to check.
  // `threshold (0 - 100): Set the threshold of the  detection. At high threshold values,
  //     only very close objects will be detected. At low values, farther objects (and possibly
  //     the rolling surface itself) will be detected. If `threshold == 0 the default (or
  //     calibration) threshold setting will be used. 
  //
  // `Example: obstacle_both := scribbler.obstacle(scribbler#LEFT, 0) and scribbler.obstacle(scribbler#RIGHT, 0)
  //
  //     Obstacle_both is set on left AND right obstacles, using the default sensitivity.
  if (!(threshold)) {
    threshold = (*(uint8_t *)&dat[3006]);
  }
  threshold = Min__((Max__(threshold, 1)), 100);
  FRQA = (14000 * threshold) + (20607 * (100 - threshold));
  if (side == LEFT) {
    CTRA = (4 << 26) | OBS_TX_LEFT;
    DIRA = ((DIRA & 0xffffffbf) | 0x40);
  } else {
    if (side == RIGHT) {
      CTRA = (4 << 26) | OBS_TX_RIGHT;
      DIRA = ((DIRA & 0xffff7fff) | 0x8000);
    }
  }
  waitcnt((CNT + 24000));
  result = -(((INA >> OBS_RX) & 0x1) == 0);
  DIRA &= ~(1<<OBS_TX_LEFT);
  DIRA &= ~(1<<OBS_TX_RIGHT);
  CTRA = 0;
  waitcnt((CNT + (CLKFREQ / 1000)));
  return result;
}

/*  `NOTE: The following line_threshold methods affect only the line sensor threshold used when
   line_sensor is called with a threshold value of zero.
 */
int32_t scribbler_read_line_threshold(scribbler *self)
{
  int32_t _local__0003[1];
  // Read the line threshold value from EEPROM, and substitute it for the default
  // if checksum is correct and value is reasonable.
  // Returns the threshold value read on success.
  // If no valid calibration values exist in EEPROM, sets to (and returns)the
  // default value DEFAULT_LINE_THLD.
  //
  // Example: scribbler.read_line threshold 'Get previously-written line threshold value.
  if (scribbler__ee_rdblock(self, (int32_t)(&_local__0003[0]), EE_LINE_THLD, 1)) {
    _local__0003[0] = _local__0003[0] & 0xff;
    if ((_local__0003[0] > 5) && (_local__0003[0] < 100)) {
      return scribbler_set_line_threshold(_local__0003[0]);
    }
  }
  return scribbler_default_line_threshold(self);
}

int32_t scribbler_write_line_threshold(scribbler *self)
{
  // Write current line threhsold value to EEPROM.
  // Returns true on a successful write; false otherwise.
  //
  // Example: scribbler.write_line_threshold 'Write current line threshold value to EEPROM.
  return scribbler__ee_wrblock(self, (int32_t)(&(*(uint8_t *)&dat[3005])), EE_LINE_THLD, 1);
}

int32_t scribbler_default_line_threshold(scribbler *self)
{
  // Restore line threshold to default value. DOES NOT SAVE IN EEPROM.
  // This method is optional unless read_line_threshold or set_line_threshold
  // have been called successfully.
  // Returns the default value.
  //
  // Example: scribbler.default_line_threshold 'Restore calibration default.
  return scribbler_set_line_threshold(DEFAULT_LINE_THLD);
}

int32_t scribbler_set_line_threshold(int32_t thld)
{
  // Set line sensor threshold to thld.
  // DOES NOT SAVE IN EEPROM. Returns the value set.
  //
  // Example: scribbler.set_line_threhsold(32) 'Set line sensor threshold to 32.
  //
  // This becomes the value used when the line_sensor method is called with an argument of zero.
  return (((uint8_t *)&dat[3005])[0] = thld);
}

int32_t scribbler_get_line_threshold()
{
  // Returns the current line sensor threshold.
  //
  // Example: Thld := scribbler.get_line_threshold
  return (*(uint8_t *)&dat[3005]);
}

int32_t scribbler_line_sensor(int32_t side, int32_t threshold)
{
  int32_t result = 0;
  // If threshold => 0
  //   Return the value of the line sensor on side (LEFT or RIGHT),
  //   compared to the threshold. (If threshold is zero, substitute 40.)
  //   Return: false == dark; true == light
  // If threshold < 0
  //   Return analog value of line sensor.
  //
  // Example: if (scribbler.line_sensor(scribbler#LEFT, 0)) 'IF block executed if left line sensor seeing default bright reflection.
  if (side == LEFT) {
    result = Shr__(((uint16_t *)(*(int32_t *)&dat[1828]))[ADC_LEFT_LIN], 8);
  } else {
    if (side == RIGHT) {
      result = Shr__(((uint16_t *)(*(int32_t *)&dat[1828]))[ADC_RIGHT_LIN], 8);
    }
  }
  if (threshold == 0) {
    result = -(result >= (*(uint8_t *)&dat[3005]));
  } else {
    if (threshold > 0) {
      result = -(result >= threshold);
    }
  }
  return result;
}

int32_t scribbler_read_light_calibration(scribbler *self)
{
  int32_t _local__0004[1];
  // Read light calibration values from EEPROM, and use them if they're reasonable.
  // Returns the calibration values (packed long) on success.
  // If no valid calibration values exist in EEPROM, sets to (and returns)the
  // default values.
  //
  // Example: scribbler.read_light_calibration 'Get previously-written light calibration values.
  if (scribbler__ee_rdblock(self, (int32_t)(&_local__0004[0]), EE_LIGHT_CALIB, 3)) {
    return scribbler_set_light_calibration(self, ((_local__0004[0] << 24) >> 24), ((_local__0004[0] << 16) >> 24), ((_local__0004[0] << 8) >> 24));
  } else {
    return scribbler_default_light_calibration(self);
  }
}

int32_t scribbler_write_light_calibration(scribbler *self)
{
  int32_t _local__0005[1];
  // Write current light calibration values to EEPROM.
  // Returns true on a successful write; false otherwise.
  //
  // Example: scribbler.write_light_calibration 'Write current light calibration values to EEPROM.
  _local__0005[0] = scribbler_get_light_calibration();
  return scribbler__ee_wrblock(self, (int32_t)(&_local__0005[0]), EE_LIGHT_CALIB, 3);
}

int32_t scribbler_default_light_calibration(scribbler *self)
{
  // Restore light calibration to default values. DOES NOT SAVE IN EEPROM.
  // This method is optional unless read_light_calibration or set_light_calibration
  // have been called successfully.
  // Returns a packed long containing the default values.
  //
  // Example: scribbler.default_light_calibration 'Restore calibration defaults.
  return scribbler_set_light_calibration(self, DEFAULT_LIGHT_SCALE, DEFAULT_LIGHT_SCALE, DEFAULT_LIGHT_SCALE);
}

int32_t scribbler_set_light_calibration(scribbler *self, int32_t left_scale, int32_t center_scale, int32_t right_scale)
{
  int32_t _parm__0006[4];
  _parm__0006[0] = left_scale;
  _parm__0006[1] = center_scale;
  _parm__0006[2] = right_scale;
  // Set light calibration values to method's arguments (-128 to 127).
  // DOES NOT SAVE IN EEPROM. Returns a packed long containing the new values.
  //
  // Example: scribbler.set_light_calibration(-5, 25, 0) 'Set left scale to -5,
  //                                              'center scale to 25, and
  //                                              'right scale to 0.
  //
  // Calibration values are signed and are added to the results of the light_sensor_log method.
  for(_parm__0006[3] = 0; _parm__0006[3] <= 2; _parm__0006[3]++) {
    ((uint8_t *)&dat[3004])[_parm__0006[3]] = Min__((Max__((&_parm__0006[0])[_parm__0006[3]], (-128))), 127);
  }
  return scribbler_get_light_calibration();
}

int32_t scribbler_get_light_calibration()
{
  // Returns a packed long containing the current light calibration values:
  //
  //  31          24 23          16 15           8 7           0
  // +----------------------------------------------------------+    
  // |       0      |  Right Scale | Center Scale |  Left Scale |
  // +----------------------------------------------------------+
  //
  // Example: CenterCal := (scribbler.get_light_calibration >> 8) & $ff
  return ((((uint8_t *)&dat[3004])[0] | (((uint8_t *)&dat[3004])[1] << 8)) | (((uint8_t *)&dat[3004])[2] << 16));
}

int32_t scribbler_light_sensor(scribbler *self, int32_t side)
{
  int32_t result = 0;
  // Return the square root (0 .. 255) of the value of the light sensor on side (LEFT, CENTER, or RIGHT).
  // The square-root-scaled value provides a wider dynamic range over a small numerical range than the
  // raw values do.
  //
  // Example: if (scribbler.light_sensor(scribbler#LEFT) > scribbler.light_sensor(scribbler#RIGHT)) 'IF block executed if uncalibrated left is brighter than right.
  if ((result = scribbler_light_sensor_word(side)) == UNDEF) {
    return 0;
  }
  result = Sqrt__(result);
  return result;
}

int32_t scribbler_light_sensor_log(scribbler *self, int32_t side)
{
  int32_t	wsense, lsense, ssense, mant, Char;
  int32_t result = 0;
  static int32_t look__0070[] = {LEFT, CENTER, RIGHT, };

  // Return a log-like function (0 .. 255) of the value of the light sensor on side (LEFT, CENTER, or RIGHT).
  // The log-scaled value provides a wider dynamic range over a small numerical range than the
  // raw values do and more sensitivity to change at lower light levels than the square-root funciton above.
  //
  // Example: if (scribbler.light_sensor_log(scribbler#LEFT) > scribbler.light_sensor_log(scribbler#RIGHT)) 'IF block executed if calibrated left is brighter than right.
  if ((wsense = scribbler_light_sensor_word(side)) == UNDEF) {
    return 0;
  }
  if ((Char = (BitEncode__(wsense)) - 1) < 0) {
    return 0;
  }
  lsense = Shr__((wsense << (31 - Char)), 20);
  mant = ((uint16_t *)(49152 + ((lsense & 0x7ff) << 1)))[0];
  lsense = Min__(((((Char << 4) | (Shr__(mant, 12))) << 8) / 245), 255);
  ssense = Sqrt__((Min__(((wsense << 15) / 30000), 65535)));
  result = Min__((Max__(((((ssense * (255 - ssense)) + (lsense * ssense)) / 255) + ((((uint8_t *)&dat[3004])[Lookdown__(side, 0, look__0070, 3)] << 24) >> 24)), 0)), 255);
  return result;
}

int32_t scribbler_light_sensor_raw(scribbler *self, int32_t side)
{
  int32_t result = 0;
  // Return the raw value (0 .. 4095) of the light sensor on side (LEFT, CENTER, or RIGHT).
  //
  // Example: if (scribbler.light_sensor_raw(scribbler#LEFT) > scribbler.light_sensor(scribbler#RIGHT)) 'IF block executed if left is brighter than right.
  if ((result = scribbler_light_sensor_word(side)) == UNDEF) {
    return 0;
  }
  result = Shr__(result, 4);
  return result;
}

int32_t scribbler_light_sensor_word(int32_t side)
{
  if (side == LEFT) {
    return ((uint16_t *)(*(int32_t *)&dat[1828]))[ADC_LEFT_LGT];
  } else {
    if (side == CENTER) {
      return ((uint16_t *)(*(int32_t *)&dat[1828]))[ADC_CENTER_LGT];
    } else {
      if (side == RIGHT) {
        return ((uint16_t *)(*(int32_t *)&dat[1828]))[ADC_RIGHT_LGT];
      } else {
        return UNDEF;
      }
    }
  }
}

int32_t scribbler_get_results(int32_t index)
{
  // General accessor for ADC Results array: returns the full word value.
  //
  // Example: battery_level := scribbler.get_adc_results(scribbler#ADC_VBAT) 'Query the battery voltage and save in battery_level.
  return ((uint16_t *)(*(int32_t *)&dat[1828]))[index];
}

int32_t scribbler_get_adc_results(int32_t index)
{
  // General accessor for ADC Results array: returns upper eight bits of word value.
  //
  // Example: battery_level := scribbler.get_adc_results(scribbler#ADC_VBAT) 'Query the battery voltage and save in battery_level.
  return (Shr__(((uint16_t *)(*(int32_t *)&dat[1828]))[index], 8));
}

//
//
// -------[ Button methods... ]-------------------------------------------------
//
// Button methods control and sense the user's interaction with the scribbler's push button.
int32_t scribbler_button_press()
{
  // Return true if button is down, false if button is up.
  //
  // Example: if(scribbler.button_press) 'IF block executed if button is down.
  return -(((INA >> BUTTON) & 0x1) == 0);
}

int32_t scribbler_button_count()
{
  int32_t result = 0;
  // Get the last count of button presses (0 - 8). Then zero the count.
  //
  // Example: button_presses := scribbler.button_count 'Button_presses is set to the recent button press count, which is then zeroed.
  if ((result = ((uint8_t *)(*(int32_t *)&dat[1828]))[0x2c])) {
    ((uint8_t *)(*(int32_t *)&dat[1828]))[0x2c] = 0;
  }
  return result;
}

int32_t scribbler_reset_button_count()
{
  // Return the reset button count (0- 8). Zero indicates a power-on or PC-initiated reset.
  //
  // Example: reset_button_presses := scribbler.reset_button_count 'Reset_button_presses is set to the button press count that caused the reset.
  return (*(uint8_t *)&dat[4721]);
}

int32_t scribbler_button_mode(int32_t led_enable, int32_t reset_enable)
{
  ((uint8_t *)(*(int32_t *)&dat[1828]))[0x2d] = (LED_ENA & -(led_enable != 0)) | (RST_ENA & -(reset_enable != 0));
  return 0;
}

//
//
// -------[ LED methods... ]----------------------------------------------------
//
// LED methods control the red/green user LEDs and blue power LED.
int32_t scribbler_set_leds(scribbler *self, int32_t left_color, int32_t center_color, int32_t right_color, int32_t power_color)
{
  // Sets all LEDs for which the color argument <> NO_CHANGE (-1).
  // See the above constants for predefined indices and colors.
  //
  // Example: scribbler.set_leds(scribbler#RED, scribbler#NO_CHANGE, scribbler#BLINK_GREEN, scribbler#OFF) 'Set LEDs (L to R): RED, same, blinking GREEN, off.
  if (left_color != NO_CHANGE) {
    scribbler_set_led(LEFT, left_color);
  }
  if (center_color != NO_CHANGE) {
    scribbler_set_led(CENTER, center_color);
  }
  if (right_color != NO_CHANGE) {
    scribbler_set_led(RIGHT, right_color);
  }
  if (power_color != NO_CHANGE) {
    scribbler_set_led(POWER, power_color);
  }
  return 0;
}

int32_t scribbler_set_led(int32_t index, int32_t color)
{
  int32_t	shift;
  ((uint8_t *)(((*(int32_t *)&dat[1828]) + (LED_BYTES << 1)) + (index & 0x3)))[0] = color;
  return 0;
}

//
//
// -------[ Sound methods... ]--------------------------------------------------
//
// Sound methods control the output from the scribbler's built-in speaker.
int32_t scribbler_beep(scribbler *self)
{
  // Set volume level to 50%, and send a 150ms 1 KHz tone, followed by a 350ms pause.
  //
  // Example: scribbler.beep 'Make the speaker beep.
  scribbler_set_volume(self, 50);
  scribbler_set_voices(SIN, SIN);
  scribbler_play_tone(self, 150, 1000, 0);
  return scribbler_play_tone(self, 350, 0, 0);
}

int32_t scribbler_command_tone(int32_t cmd_tone)
{
  // Send an immediate command (cmd_tone) to the sound cog:
  //
  //   STOP:  Stops sound production immediately, then clears the sound queue.
  //   PAUSE: Pauses sound production after the note currently being played.
  //   PLAY:  Resumes sound production from the queue.
  //
  // Example: scribbler.command_tone(STOP) 'Cause sounds to cease immediately.
  if (cmd_tone == STOP || cmd_tone == PAUSE || cmd_tone == PLAY) {
    ((uint8_t *)&dat[4712])[0] = cmd_tone;
    while ((*(uint8_t *)&dat[4712])) {
      Yield__();
    }
    if (cmd_tone == STOP) {
      ((uint16_t *)&dat[4708])[0] = (*(uint16_t *)&dat[4710]);
    }
  }
  return 0;
}

int32_t scribbler_set_volume(scribbler *self, int32_t vol)
{
  // Set the current volume level to vol (0 - 100) percent.
  //
  // Example: scribbler.set_volume(50) 'Set volume level to 50%.
  return scribbler__enqueue_tone((0x2000 | (((Min__((Max__(vol, 0)), 100)) * 8191) / 100)));
}

int32_t scribbler_set_voices(int32_t v1, int32_t v2)
{
  // Set voices for both channels (SQU, SAW, TRI, SIN)
  //
  // Example: scribbler.set_voices(scribbler#SIN, scribbler#TRI) 'Set voice 1 to sine wave; voice 2 to triangle wave.
  ((uint8_t *)&dat[4714])[0] = v1 & 0x3;
  ((uint8_t *)&dat[4715])[0] = v2 & 0x3;
  return 0;
}

int32_t scribbler_play_sync(scribbler *self, int32_t value)
{
  // Insert a SYNC command into the sound queue.
  // When the sound processor encounters it, it writes value (0 - 255) to
  // the hub variable Tone_sync, then continues. This method can be used to
  // synchronize motion to the sound being played.
  //
  // Example: scribbler.play_sync(12)    'Insert a SYNC 12 into the tone queue.
  //                              'When encountered during play, player will set the sync value to 12
  //                              '(for get_sync) and continue with the next command.
  return scribbler__enqueue_tone((0x4000 | (value & 0xff)));
}

int32_t scribbler_play_pause(scribbler *self, int32_t value)
{
  // Insert a PAUS command into the sound queue.
  // When the sound processor encounters it, it writes value (0 - 255) to
  // the hub variable Tone_sync, then pauses.
  //
  // Example: scribbler.play_pause(12)   'Insert a PAUS 12 into the tone queue.
  //                              'When encountered during play, player will set the sync value to 12
  //                              '(for get_sync) and wait for a PLAY command to resume.
  return scribbler__enqueue_tone((0x6000 | (value & 0xff)));
}

int32_t scribbler_get_sync()
{
  int32_t result = 0;
  // Get the current Tone_sync value.
  //
  // Example: current_sync := scribbler.get_sync 'Get the latest sync value written from tone queue while playing,
  //                                      'then zero the value if it was non-zero.
  if ((result = (*(uint8_t *)&dat[4713]))) {
    ((uint8_t *)&dat[4713])[0] = 0;
  }
  return result;
}

int32_t scribbler_play_tone(scribbler *self, int32_t time, int32_t frq1, int32_t frq2)
{
  // Send sound to speaker, mixing frq1 & frq2 (1 - 10000 Hz),
  // using current voices and volume for time (0 - 8191 milliseconds).
  //
  // Example: scribbler.play_tone(1000, 440, 880) 'Play an A440 and A880 for 1000 milliseconds.
  if (!(time)) {
    return 0;
  }
  scribbler__enqueue_tone((time & 0x1fff));
  scribbler__enqueue_tone((((*(uint8_t *)&dat[4714]) << 14) | (frq1 & 0x3fff)));
  return scribbler__enqueue_tone((((*(uint8_t *)&dat[4715]) << 14) | (frq2 & 0x3fff)));
}

int32_t scribbler_play_tones(scribbler *self, int32_t addr)
{
  int32_t result = 0;
  // Add a command sequence to the tone queue. Commands are of the
  // following format:
  //
  // 15  13 12                      0
  // +-------------------------------+
  // | Cmd |          Data           |
  // +-------------------------------+
  //
  // Cmd: %000
  //
  //   Play tone for duration Data (0 - 8192ms),using the following TWO words as
  //   the voices, each having the following format:
  //
  //    15 14 13                        0
  //     +-------------------------------+
  //     |Voc|         Frequency         |
  //     +-------------------------------+
  //
  //      Voc (voice):
  //
  //        00 = square wave
  //        01 = sawtooth wave
  //        10 = triangle wave
  //        11 = sine wave
  //
  //     Frequency : 0 (no sound) to 16363 Hz.
  //
  // Cmd: %001
  //
  //   Set volume to Data << 3 (range 0 - 0.9998)
  //
  // Cmd: %010
  //
  //   Set sync to Data & $ff
  //
  // Cmd: %011
  //
  //   Set sync to Data & $ff, then PAUSE.
  //
  // Example: scribbler.play_tones(@tone_buffer) 'Add tones from tone_buffer (word array) to tone queue until a zero word is encountered.         
  while (((uint16_t *)addr)[0]) {
    result = scribbler__enqueue_tone(((uint16_t *)addr)[0]);
    addr = addr + 2;
  }
  return result;
}

int32_t scribbler_wait_sync(int32_t value)
{
  // Wait for sync in queue to echo (value <> 0) or for queue to become empty (value == 0).
  //
  // Example: scribbler.wait_sync(12) 'Wait until a sync value of 12 is returned from the tone queue.
  if ((*(uint8_t *)&dat[4718])) {
    if (value) {
      while (!(((uint8_t *)&dat[4713])[0] == value)) {
        Yield__();
      }
    } else {
      while (!(((uint16_t *)&dat[4710])[0] == ((uint16_t *)&dat[4708])[0])) {
        Yield__();
      }
    }
  }
  return 0;
}

//
//
// -------[ Time methods... ]---------------------------------------------------
//
// Time methods control and sense the scribbler's built-in millisecond timers and provide
// a convenient delay function.
int32_t scribbler_start_timer(int32_t number)
{
  // Start a 1 KHz count-up timer number (0 - 7), which counts up from zero
  // by one every millisecond.
  //
  // Example: scribbler.start_timer(4) 'Restarts timer number four from zero.
  if ((number >= 0) && (number < 8)) {
    ((int32_t *)&dat[2940])[number] = ((int32_t *)((*(int32_t *)&dat[1828]) + 0xa))[0];
  }
  return 0;
}

int32_t scribbler_get_timer(int32_t number)
{
  // Return the time (in milliseconds, up to 2 million seconds ~ 24 days) from the 1 KHz count-up timer number (0 - 7).
  // If number is outside the range 0 - 7, return the value of the master timer, which starts at 0 when scribbler is started.
  //
  // Example: elapsed_time := scribbler.get_timer(4) 'Get time elapsed since Propeller reset or timer restart.
  return (((int32_t *)((*(int32_t *)&dat[1828]) + 0x28))[0] - (((int32_t *)&dat[2940])[number] & -(-(number >= 0) && -(number < 8))));
}

int32_t scribbler_delay_tenths(int32_t time)
{
  int32_t	time0;
  // Time delay in tenths of a second.
  //
  // Example: scribbler.delay_tenths(20) 'Wait a couple seconds.
  time0 = CNT;
  {
    int32_t _idx__0071;
    int32_t _limit__0072 = time;
    for(_idx__0071 = 0; _idx__0071 < _limit__0072; _idx__0071++) {
      waitcnt((time0 = time0 + (CLKFREQ / 10)));
    }
  }
  return 0;
}

//
//
// -------[ EEPROM methods... ]-------------------------------------------------
//
// EEPROM methods allow read/write access to the auxilliary 32Kbyte EEPROM.
int32_t scribbler_ee_read_byte(scribbler *self, int32_t addr)
{
  // Read byte from aux EEPROM at addr.
  //
  // Example: my_data := scribbler.ee_read_byte($2000) 'Set my_data equal to byte at location $2000 in auxilliary EEPROM.
  return scribbler__ee_rdbyte(self, addr);
}

int32_t scribbler_ee_write_byte(scribbler *self, int32_t addr, int32_t data)
{
  // Write byte to aux EEPROM at addr, if addr is in user area.
  //
  // Example: scribbler.ee_write_byte(scribbler#EE_USER_AREA + 5, 35) 'Write the value 35 to the sixth byte in the auxilliary EEPROM's user area.
  if (addr >= EE_USER_AREA) {
    scribbler__ee_wrbyte(self, addr, data);
    return -1;
  } else {
    return 0;
  }
}

//
//
// -------[ hardware model methods... ]-----------------------------------------
//
int32_t scribbler_get_model_s2()
{
  // Returns True if the Robot is an S2
  //  Example: if scribbler.get_model_s2
  //             sio.str(string("My Robot is an S2!"))
  return -((*(uint8_t *)&dat[4723]) == MODEL_S2);
}

int32_t scribbler_get_model_s3()
{
  // Returns True if the Robot is an S3
  //  Example: if scribbler.get_model_s3
  //   sio.str(string("My Robot is an S3!"))
  return -((*(uint8_t *)&dat[4723]) == MODEL_S3);
}

//
//
// -------[ S3 specific methods... ]--------------------------------------------
//
int32_t scribbler_set_power_off(scribbler *self)
{
  // Powers Off the S3 when the USB cable is not connected
  //  Example: scribbler.set_power_off
  if (scribbler_get_model_s3()) {
    // Disable the charger watch dog timer. 
    scribbler__BQ2495_wrbyte(self, 5, 142);
    // Disable the main battery FET
    return scribbler__BQ2495_wrbyte(self, 7, 104);
  } else {
    return 0;
  }
}

int32_t scribbler_get_usb_powered(scribbler *self)
{
  // Returns True if a USB cable is powering the Scribbler
  //  Example: if scribbler.get_usb_powered
  //             sio.str(string("USB Power Connected"))
  if (scribbler_get_model_s3()) {
    return (scribbler__BQ2495_rdbyte(self, 8) & (1 << 2));
  } else {
    return 0;
  }
}

int32_t scribbler_get_charging(scribbler *self)
{
  int32_t	Register;
  // Returns True if the Scribbler is charging its battery
  //  Example: if scribbler.get_charging
  //             sio.str(string("Charging"))
  if (scribbler_get_model_s3()) {
    Register = scribbler__BQ2495_rdbyte(self, 8) & 0x30;
    return -(-(Register == 32) || -(Register == 16));
  } else {
    return 0;
  }
}

//
//
// =======[ Private Spin methods... ]==============================================
//
// These private methods are used internally and are not accessible to the user.
//
// -------[ Miscellaneous... ]--------------------------------------------------
static int32_t scribbler__compute_calibration()
{
  // Compute other values dependent on Full_circle to save time in methods.
  ((uint16_t *)&dat[2996])[0] = Shr__((*(uint16_t *)&dat[2992]), 1);
  ((uint16_t *)&dat[2998])[0] = Shr__((*(uint16_t *)&dat[2992]), 2);
  ((int32_t *)&dat[3000])[0] = ((*(uint16_t *)&dat[2992]) * 56841) / 100000;
  return 0;
}

static int32_t scribbler__atan2(int32_t y, int32_t x)
{
  int32_t	arg, adder, n;
  int32_t result = 0;
  // Four-quadrant arctangent. Y and X are signed integers.
  // Full_circle is an integer equal to the number of units in a full circle.
  if ((n = BitEncode__((Min__((abs(x)), (abs(y)))))) > 21) {
    x = x >> (n - 21);
    y = y >> (n - 21);
  }
  if ((abs(x)) > (abs(y))) {
    arg = (y << 10) / x;
    adder = (*(uint16_t *)&dat[2996]) & -(x < 0);
  } else {
    arg = ((-x) << 10) / y;
    adder = (*(uint16_t *)&dat[2998]) + ((*(uint16_t *)&dat[2996]) & -(y < 0));
  }
  result = (Shr__(((((abs(arg)) * (*(int32_t *)&dat[3000])) / (914 + (Shr__((arg * arg), 12)))) + 1), 2)) - -((abs(arg)) >= 960);
  if (arg < 0) {
    result = -result;
  }
  result = result + adder;
  result = result + ((*(uint16_t *)&dat[2992]) & -(result < 0));
  return result;
}

static int32_t scribbler__enqueue_tone(int32_t tone_word)
{
  int32_t	next_ptr;
  // Wait for tone queue to become non-full,
  // then add tone_word to it.
  if ((*(uint8_t *)&dat[4718])) {
    next_ptr = (*(uint16_t *)&dat[4708]) + 1;
    next_ptr = next_ptr & -(next_ptr < _TONE_Q_SIZE);
    while (!(((uint16_t *)&dat[4710])[0] != next_ptr)) {
      Yield__();
    }
    ((uint16_t *)&dat[3108])[(*(uint16_t *)&dat[4708])] = tone_word;
    ((uint16_t *)&dat[4708])[0] = next_ptr;
    return (((*(uint16_t *)&dat[4708]) << 16) | (*(uint16_t *)&dat[4710]));
  }
  return 0;
}

// -------[ I2C Methods... ]----------------------------------------------------
static int32_t scribbler__i2c_rd(int32_t acknak)
{
  int32_t result = 0;
  {
    int32_t _idx__0073;
    for(_idx__0073 = 0; _idx__0073 < 8; _idx__0073++) {
      OUTA = ((OUTA & 0xefffffff) | 0x10000000);
      result = (result << 1) | ((INA >> SDA) & 0x1);
      OUTA &= ~(1<<SCL);
    }
  }
  DIRA = ((DIRA & 0xdfffffff) | ((-(acknak != 0) & 0x1) << SDA));
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  OUTA &= ~(1<<SCL);
  DIRA &= ~(1<<SDA);
  return result;
}

static int32_t scribbler__i2c_wr(int32_t data)
{
  int32_t result = 0;
  {
    int32_t _idx__0074;
    for(_idx__0074 = 0; _idx__0074 < 8; _idx__0074++) {
      DIRA = ((DIRA & 0xdfffffff) | ((-(((data = data << 1) & 0x100) == 0) & 0x1) << SDA));
      OUTA = ((OUTA & 0xefffffff) | 0x10000000);
      OUTA &= ~(1<<SCL);
    }
  }
  DIRA &= ~(1<<SDA);
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  result = -(((INA >> SDA) & 0x1) == 0);
  OUTA &= ~(1<<SCL);
  return result;
}

static int32_t scribbler__i2c_start()
{
  DIRA &= ~(1<<SDA);
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  DIRA = ((DIRA & 0xdfffffff) | 0x20000000);
  OUTA &= ~(1<<SCL);
  return 0;
}

static int32_t scribbler__i2c_stop()
{
  OUTA &= ~(1<<SCL);
  DIRA = ((DIRA & 0xdfffffff) | 0x20000000);
  OUTA = ((OUTA & 0xefffffff) | 0x10000000);
  DIRA &= ~(1<<SDA);
  return 0;
}

// -------[ EEPROM Methods... ]-------------------------------------------------   
static int32_t scribbler__ee_rdblock(scribbler *self, int32_t dest_addr, int32_t addr, int32_t size)
{
  int32_t	i, csum;
  csum = scribbler__ee_rdbyte(self, (addr + size));
  {
    int32_t _limit__0075 = (size - 1);
    int32_t _step__0076 = 1;
    i = 0;
    if (i >= _limit__0075) _step__0076 = -_step__0076;
    do {
      csum = csum + (((uint8_t *)dest_addr)[i] = scribbler__ee_rdbyte(self, (addr + i)));
      i = i + _step__0076;
    } while (((_step__0076 > 0) && (i <= _limit__0075)) || ((_step__0076 < 0) && (i >= _limit__0075)));
  }
  return -((csum & 0xff) == 0);
}

static int32_t scribbler__ee_wrblock(scribbler *self, int32_t src_addr, int32_t addr, int32_t size)
{
  int32_t	i, data, csum;
  int32_t result = 0;
  csum = 0;
  result = -1;
  {
    int32_t _limit__0077 = (size - 1);
    int32_t _step__0078 = 1;
    i = 0;
    if (i >= _limit__0077) _step__0078 = -_step__0078;
    do {
      data = ((uint8_t *)src_addr)[i];
      csum = csum - data;
      result = result & scribbler__ee_wrbyte(self, (addr + i), data);
      i = i + _step__0078;
    } while (((_step__0078 > 0) && (i <= _limit__0077)) || ((_step__0078 < 0) && (i >= _limit__0077)));
  }
  result = result & scribbler__ee_wrbyte(self, (addr + size), (csum & 0xff));
  return result;
}

static int32_t scribbler__ee_rdbyte(scribbler *self, int32_t addr)
{
  int32_t result = 0;
  scribbler__ee_waddr(addr);
  scribbler__i2c_start();
  if (scribbler_get_model_s2()) {
    scribbler__i2c_wr(163);
  } else {
    scribbler__i2c_wr(161);
    addr = addr + 32768;
  }
  result = scribbler__i2c_rd(NAK);
  scribbler__i2c_stop();
  return result;
}

static int32_t scribbler__ee_wrbyte(scribbler *self, int32_t addr, int32_t data)
{
  int32_t result = 0;
  scribbler__ee_waddr(addr);
  result = scribbler__i2c_wr(data);
  scribbler__i2c_stop();
  return result;
}

static int32_t scribbler__ee_waddr(int32_t addr)
{
  if (scribbler_get_model_s2()) {
    do {
      scribbler__i2c_start();
    } while (!(scribbler__i2c_wr(162)));
  } else {
    do {
      scribbler__i2c_start();
    } while (!(scribbler__i2c_wr(160)));
    addr = addr + 32768;
  }
  scribbler__i2c_wr((Shr__(addr, 8)));
  scribbler__i2c_wr((addr & 0xff));
  return 0;
}

// -------[ Charger Methods... ]------------------------------------------------
static int32_t scribbler__BQ2495_rdbyte(scribbler *self, int32_t addr)
{
  int32_t result = 0;
  scribbler__BQ2495_waddr(addr);
  scribbler__i2c_start();
  scribbler__i2c_wr(215);
  result = scribbler__i2c_rd(NAK);
  scribbler__i2c_stop();
  return result;
}

static int32_t scribbler__BQ2495_wrbyte(scribbler *self, int32_t addr, int32_t data)
{
  int32_t result = 0;
  scribbler__BQ2495_waddr(addr);
  result = scribbler__i2c_wr(data);
  scribbler__i2c_stop();
  return result;
}

static int32_t scribbler__BQ2495_waddr(int32_t addr)
{
  do {
    scribbler__i2c_start();
  } while (!(scribbler__i2c_wr(214)));
  scribbler__i2c_wr((Min__(addr, 10)));
  return 0;
}

// =======[ License ]===========================================================
/* 
+------------------------------------------------------------------------------------------------------------------------------+
|                                                   TERMS OF USE: MIT License                                                  | 
+------------------------------------------------------------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    | 
|files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
|modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
|is furnished to do so, subject to the following conditions:                                                                   |
|                                                                                                                              |
|The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
|                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
|WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
|COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
|ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
+------------------------------------------------------------------------------------------------------------------------------+
 */
